
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdint.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/signal.h>

#include <sys/types.h>
#include <ctype.h>
#include <stdarg.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <errno.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <regex.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

enum
{
  PROC_INP = 1, PROC_OUTP = 2, PROC_ERR = 4
};
typedef struct
{
  char *name;
  char *value;
} symbol_t;
struct symtab_t_NODE;
typedef struct
{
  struct symtab_t_NODE *root;

} symtab_t;
typedef struct
{
  int nelts;
  int size;
  symtab_t **elts;
} context_t;
struct strlist_t_NODE
{
  struct strlist_t_NODE *prev, *next;
  char *data;
};
typedef struct
{
  struct strlist_t_NODE head;
} strlist_t;
typedef struct
{
  enum
  { fn_user, fn_builtin } kind;
  char *name;
  strlist_t args;
  void *data;
} func_t;
struct symbollist_t_NODE
{
  struct symbollist_t_NODE *prev, *next;
  symbol_t *data;
};
typedef struct
{
  struct symbollist_t_NODE head;
} symbollist_t;
typedef struct
{
  symbollist_t *fields;
  char **triggers;
  char **outputs;
  char *message;
  char *action;
} command_t;
struct commandlist_t_NODE
{
  struct commandlist_t_NODE *prev, *next;
  command_t *data;
};
typedef struct
{
  struct commandlist_t_NODE head;
} commandlist_t;
struct strtree_t_NODE;
typedef struct
{
  struct strtree_t_NODE *root;

} strtree_t;

int ipret_block (char *fn, char *input);
char *fs_dirname (char *x);
char *fs_normalize (char *dir);
size_t vgenprintf (void (*write) (void *arg, const char *buf, size_t len),
		   void *arg, const char *fmt, va_list args);
size_t genprintf (void (*write) (void *arg, const char *buf, size_t len),
		  void *arg, const char *fmt, ...);
size_t fdprintf (int fd, const char *fmt, ...);
char *vmprintf (const char *fmt, va_list ap);
size_t vnprintf (const char *fmt, va_list ap);
char *mprintf (const char *fmt, ...);
int ipret_file (char *dir, char *fn);
time_t get_modtime (char *fn);
time_t get_modtime_weak (char *fn);
int proc_kill (int id, int sig);
int proc_start (char *fn, char **argv, int opts);
int proc_end (int id, int *st);
int proc_input (int id);
int proc_output (int id);
int proc_error (int id);
int proc_islive (int id);
int proc_run (char *fn, char **argv, int *arg, char *inp, size_t inp_l,
	      char **outp, size_t * outp_l, char **err, size_t * err_l);
void symtab_init (symtab_t * t);
symbol_t *symtab_destroy (symtab_t * t);
symbol_t *symtab_find (symtab_t * t, symbol_t * key);
int symtab_insert (symtab_t * t, symbol_t * data);
symbol_t *symtab_remove (symtab_t * t, symbol_t * key);
context_t *context_new ();
void context_init (context_t * L);
symtab_t *context_pop (context_t * L);
void context_push (context_t * L, symtab_t * d);
context_t *context_destroy (context_t * L);
int context_isempty (context_t * L);
char *var_get (char *name);
void var_set (char *name, char *val);
void var_create (char *name, char *val);
void frame_enter ();
void frame_leave ();
void strlist_init (strlist_t * L);
char *strlist_destroy (strlist_t * L);
strlist_t *strlist_new ();
void strlist_append (strlist_t * L, char *data);
void strlist_prepend (strlist_t * L, char *data);
void strlist_remove (strlist_t * L, struct strlist_t_NODE *n);
int strlist_isempty (strlist_t * L);
func_t *func_new (char *name);
func_t *func_get (char *name);
void func_remove (char *name);
void func_init ();
void symbollist_init (symbollist_t * L);
symbol_t *symbollist_destroy (symbollist_t * L);
symbollist_t *symbollist_new ();
void symbollist_append (symbollist_t * L, symbol_t * data);
void symbollist_prepend (symbollist_t * L, symbol_t * data);
void symbollist_remove (symbollist_t * L, struct symbollist_t_NODE *n);
int symbollist_isempty (symbollist_t * L);
void commandlist_init (commandlist_t * L);
command_t *commandlist_destroy (commandlist_t * L);
commandlist_t *commandlist_new ();
void commandlist_append (commandlist_t * L, command_t * data);
void commandlist_prepend (commandlist_t * L, command_t * data);
void commandlist_remove (commandlist_t * L, struct commandlist_t_NODE *n);
int commandlist_isempty (commandlist_t * L);
void cmd_init ();
void prepare_commands ();
void strtree_init (strtree_t * t);
char *strtree_destroy (strtree_t * t);
char *strtree_find (strtree_t * t, char *key);
int strtree_insert (strtree_t * t, char *data);
char *strtree_remove (strtree_t * t, char *key);
void run_commands ();
extern commandlist_t *commands;
typedef struct
{
  int nelts;
  int size;
  char **elts;
} sstack_t;
struct charbuffer_t_node
{
  struct charbuffer_t_node *next;
  int len;
  char data[500];
};
typedef struct
{
  struct charbuffer_t_node *first;
  struct charbuffer_t_node *last;
} charbuffer_t;
typedef struct
{
  char *fn;
  time_t mtime;
} mtime_entry_t;
struct mtimecache_t_NODE
{
  struct mtimecache_t_NODE *left, *right;
  int height;
  mtime_entry_t *data;
};

typedef struct
{
  struct mtimecache_t_NODE *root;

} mtimecache_t;
typedef struct pr
{
  struct pr *prev, *next;
  int pid;
  int status;
  int fds[6];
  int socks;

  int ecode;			/* exit reason (exit/signal) */
  int earg;			/* exit code or signal name */
} pr_t;
enum
{
  PROC_RUNNING = 1, PROC_DEAD, PROC_STOPPED
};
struct symtab_t_NODE
{
  struct symtab_t_NODE *left, *right;
  int height;
  symbol_t *data;
};

struct functab_t_NODE
{
  struct functab_t_NODE *left, *right;
  int height;
  func_t *data;
};

typedef struct
{
  struct functab_t_NODE *root;

} functab_t;

struct strtree_t_NODE
{
  struct strtree_t_NODE *left, *right;
  int height;
  char *data;
};

static void
program_usage (char **argv)
{
  fprintf (stderr, "%s: options\n", argv[0]);

  fprintf (stderr, "%s\n", "-m");

  fprintf (stderr, "\t%s\n",
	   "Causes JJ to print messages " "instead of the executed commands");

  fprintf (stderr, "%s\n", "-v");

  fprintf (stderr, "\t%s\n", "Prints the version number and exits");

  exit (1);
}

static void
shift_argv (int *argc, char **argv, int pos, int amt)
{
  int i;
  for (i = pos; i + amt < *argc; i++)
    argv[i] = argv[i + amt];
  *argc -= amt;
}

static void init_interpreter ();
static void get_wd ();
static sstack_t *sstack_new ();
static void sstack_init (sstack_t * L);
static char *sstack_pop (sstack_t * L);
static void sstack_push (sstack_t * L, char *d);
static sstack_t *sstack_destroy (sstack_t * L);
static int sstack_isempty (sstack_t * L);
static char *file_read_all (char *fn);
static int do_div (long long int *x, int y);
static void do_error (char *fn, char *ref, char *msg);
static char *make_str (char *b, int L);
static void call_function (char *name, sstack_t * stack);
static void bind_args (strlist_t * arglist, sstack_t * stack);
static void expand_args (sstack_t * stack);
static void charbuffer_init (charbuffer_t * B);
static charbuffer_t *charbuffer_new ();
static void charbuffer_append (charbuffer_t * B, char D);
static char *charbuffer_collect (charbuffer_t * B, int *size);
static char *charbuffer_collectd (charbuffer_t * B, int *size);
static char *charbuffer_collectda (charbuffer_t * B, int *size);
static void charbuffer_destroy (charbuffer_t * B);
static void charbuffer_destroya (charbuffer_t * B);
static char *expand_variables_in_str (char *input);
static void empty_stack (sstack_t * stack);
static void blt_print ();

static void blt_comment ();
static time_t modtime (char *fn);
static struct mtimecache_t_NODE *mtimecache_t_insert_node
  (struct mtimecache_t_NODE *t, struct mtimecache_t_NODE *n);
static int inline mtimecache_t_height (struct mtimecache_t_NODE *x);
static struct mtimecache_t_NODE *mtimecache_t_balance (struct
						       mtimecache_t_NODE *t);
static struct mtimecache_t_NODE *mtimecache_t_remove_node (struct
							   mtimecache_t_NODE
							   *t,
							   struct
							   mtimecache_t_NODE
							   *node);
static struct mtimecache_t_NODE *mtimecache_t_rotate_right (struct
							    mtimecache_t_NODE
							    *g);
static struct mtimecache_t_NODE *mtimecache_t_rotate_left (struct
							   mtimecache_t_NODE
							   *g);
static struct mtimecache_t_NODE *mtimecache_t_remove_max (struct
							  mtimecache_t_NODE
							  *t,
							  struct
							  mtimecache_t_NODE
							  **pl);
static struct mtimecache_t_NODE *mtimecache_t_remove_min (struct
							  mtimecache_t_NODE
							  *t,
							  struct
							  mtimecache_t_NODE
							  **pl);
static void mtimecache_t_calc_height (struct mtimecache_t_NODE *t);
static struct mtimecache_t_NODE *mtimecache_t_destroy_one_node
  (struct mtimecache_t_NODE *node, struct mtimecache_t_NODE **plink);
static int mtimecache_t_compare (mtime_entry_t * X1, mtime_entry_t * X2);
static struct mtimecache_t_NODE *mtimecache_t_find_node (struct
							 mtimecache_t_NODE
							 *node,
							 mtime_entry_t * key);
static void mtimecache_init (mtimecache_t * t);
static mtime_entry_t *mtimecache_destroy (mtimecache_t * t);
static mtime_entry_t *mtimecache_find (mtimecache_t * t, mtime_entry_t * key);
static int mtimecache_insert (mtimecache_t * t, mtime_entry_t * data);
static mtime_entry_t *mtimecache_remove
  (mtimecache_t * t, mtime_entry_t * key);
static void modtimes_init ();
static time_t get_modtime_force (char *fn);
static char *code_to_str (int code);
static void blt_prgout ();

static void blt_set ();
static char **strsplit (char *re, char *d);
static char *collect_substr (char *str, int len);
static void blt_local ();

static void blt_function ();
static char *get_single_string (char *str);
static char **split_string_into_array (char *str);
static void free_string_array (char **X);
static void blt_strcat ();
static void charbuffer_putstr (charbuffer_t * B, char *str);
static int string_array_len (char **x);
static void blt_foreach ();

static void blt_include ();

static void blt_replace_suffix ();
static char *find_suffix_begin (char *str);
static void charbuffer_putmem (charbuffer_t * buffer, char *mem, int len);
static void blt_nth ();
static struct symtab_t_NODE *symtab_t_insert_node
  (struct symtab_t_NODE *t, struct symtab_t_NODE *n);
static int inline symtab_t_height (struct symtab_t_NODE *x);
static struct symtab_t_NODE *symtab_t_balance (struct symtab_t_NODE *t);
static struct symtab_t_NODE *symtab_t_remove_node
  (struct symtab_t_NODE *t, struct symtab_t_NODE *node);
static struct symtab_t_NODE *symtab_t_rotate_right (struct symtab_t_NODE *g);
static struct symtab_t_NODE *symtab_t_rotate_left (struct symtab_t_NODE *g);
static struct symtab_t_NODE *symtab_t_remove_max
  (struct symtab_t_NODE *t, struct symtab_t_NODE **pl);
static struct symtab_t_NODE *symtab_t_remove_min
  (struct symtab_t_NODE *t, struct symtab_t_NODE **pl);
static void symtab_t_calc_height (struct symtab_t_NODE *t);
static struct symtab_t_NODE *symtab_t_destroy_one_node
  (struct symtab_t_NODE *node, struct symtab_t_NODE **plink);
static int symtab_t_compare (symbol_t * X1, symbol_t * X2);
static struct symtab_t_NODE *symtab_t_find_node (struct symtab_t_NODE *node,
						 symbol_t * key);
static symbol_t *find_var (char *name);
static void var_init ();
static struct functab_t_NODE *functab_t_insert_node
  (struct functab_t_NODE *t, struct functab_t_NODE *n);
static int inline functab_t_height (struct functab_t_NODE *x);
static struct functab_t_NODE *functab_t_balance (struct functab_t_NODE *t);
static struct functab_t_NODE *functab_t_remove_node
  (struct functab_t_NODE *t, struct functab_t_NODE *node);
static struct functab_t_NODE *functab_t_rotate_right (struct functab_t_NODE
						      *g);
static struct functab_t_NODE *functab_t_rotate_left (struct functab_t_NODE
						     *g);
static struct functab_t_NODE *functab_t_remove_max (struct functab_t_NODE *t,
						    struct functab_t_NODE
						    **pl);
static struct functab_t_NODE *functab_t_remove_min (struct functab_t_NODE *t,
						    struct functab_t_NODE
						    **pl);
static void functab_t_calc_height (struct functab_t_NODE *t);
static struct functab_t_NODE *functab_t_destroy_one_node
  (struct functab_t_NODE *node, struct functab_t_NODE **plink);
static int functab_t_compare (func_t * X1, func_t * X2);
static struct functab_t_NODE *functab_t_find_node (struct functab_t_NODE
						   *node, func_t * key);
static void functab_init (functab_t * t);
static func_t *functab_destroy (functab_t * t);
static func_t *functab_find (functab_t * t, func_t * key);
static int functab_insert (functab_t * t, func_t * data);
static func_t *functab_remove (functab_t * t, func_t * key);

static void blt_command ();
static strlist_t *parse_strlist (char *input);
static void prepare_command (command_t * C);
static void replace_newlines_with_spaces (char *X);
static char *get_simple_field (char *vname);
static char **get_array_field (char *vname);
static struct strtree_t_NODE *strtree_t_insert_node
  (struct strtree_t_NODE *t, struct strtree_t_NODE *n);
static int inline strtree_t_height (struct strtree_t_NODE *x);
static struct strtree_t_NODE *strtree_t_balance (struct strtree_t_NODE *t);
static struct strtree_t_NODE *strtree_t_remove_node
  (struct strtree_t_NODE *t, struct strtree_t_NODE *node);
static struct strtree_t_NODE *strtree_t_rotate_right (struct strtree_t_NODE
						      *g);
static struct strtree_t_NODE *strtree_t_rotate_left (struct strtree_t_NODE
						     *g);
static struct strtree_t_NODE *strtree_t_remove_max (struct strtree_t_NODE *t,
						    struct strtree_t_NODE
						    **pl);
static struct strtree_t_NODE *strtree_t_remove_min (struct strtree_t_NODE *t,
						    struct strtree_t_NODE
						    **pl);
static void strtree_t_calc_height (struct strtree_t_NODE *t);
static struct strtree_t_NODE *strtree_t_destroy_one_node
  (struct strtree_t_NODE *node, struct strtree_t_NODE **plink);
static int strtree_t_compare (char *X1, char *X2);
static struct strtree_t_NODE *strtree_t_find_node (struct strtree_t_NODE
						   *node, char *key);
static int execute_command (strtree_t * input_set, command_t * C);
static void blt_modify ();
static int command_has_target (command_t * C, char **targets);
static void modify_command (command_t * C, strlist_t * body);
static void modify_field (symbollist_t * SL, char *field, char *value);
static int messages_only;
static char *cwd;
static mtimecache_t *modtimes;
static int sig_installed;
static struct sigaction old_sa;
static context_t *context;
static functab_t *funcs;

void *__unused_jj_c[] = {

  (void *) sstack_init,

  (void *) charbuffer_collectd,

  (void *) mtimecache_destroy,

  (void *) code_to_str,

  (void *) functab_destroy,

  0,
};

int
main (int argc, char **argv)
{
  int loaded;
  int i;
  init_interpreter ();
  {
    int i5;
    for (i5 = 1; i5 < argc; i5++)
      {
	if (!strcmp (argv[i5], "-h"))
	  {
	    shift_argv (&argc, argv, i5, 1);
	    program_usage (argv);

	  }
	else if (!strcmp (argv[i5], "-m"))
	  {
	    shift_argv (&argc, argv, i5, 1);
	    i5--;

	    messages_only = 1;

	  }
	else if (!strcmp (argv[i5], "-v"))
	  {
	    shift_argv (&argc, argv, i5, 1);
	    i5--;

	    printf ("version: %s\n", "jj-2.0");
	    return 0;

	  }
	else if (argv[i5][0] == '-')
	  {
	    if (argv[i5][1] == '-' && !argv[i5][2])
	      {
		shift_argv (&argc, argv, i5, 1);
		break;
	      }
	    program_usage (argv);
	  }
      }				/* end for */
  }				/* end beginning scope */

  get_wd ();
  loaded = 0;
  for (i = 1; i < argc; i++)
    {
      ipret_file (cwd, argv[i]);
      loaded++;
    }
  if (!loaded)
    ipret_file (cwd, "jjcool");
  prepare_commands ();
  run_commands ();
  return 0;
}

static void
init_interpreter ()
{
  func_t *F;
  var_init ();
  func_init ();

  F = func_new ("#" "print");
  F->kind = fn_builtin;
  F->data = (void *) blt_print;

  strlist_append (&F->args, strdup ("STR"));

  F = func_new ("#" "comment");
  F->kind = fn_builtin;
  F->data = (void *) blt_comment;

  strlist_append (&F->args, strdup ("_STR"));

  F = func_new ("#" "prgout");
  F->kind = fn_builtin;
  F->data = (void *) blt_prgout;

  strlist_append (&F->args, strdup ("_RESULT"));

  strlist_append (&F->args, strdup ("_BODY"));

  F = func_new ("#" "set");
  F->kind = fn_builtin;
  F->data = (void *) blt_set;

  strlist_append (&F->args, strdup ("_VARNAME"));

  strlist_append (&F->args, strdup ("_VALUE"));

  F = func_new ("#" "local");
  F->kind = fn_builtin;
  F->data = (void *) blt_local;

  strlist_append (&F->args, strdup ("_VARNAMES"));

  F = func_new ("#" "function");
  F->kind = fn_builtin;
  F->data = (void *) blt_function;

  strlist_append (&F->args, strdup ("_NAME"));

  strlist_append (&F->args, strdup ("_ARGS"));

  strlist_append (&F->args, strdup ("_BODY"));

  F = func_new ("#" "strcat");
  F->kind = fn_builtin;
  F->data = (void *) blt_strcat;

  strlist_append (&F->args, strdup ("_RESULT"));

  strlist_append (&F->args, strdup ("_STR1"));

  strlist_append (&F->args, strdup ("_STR2"));

  F = func_new ("#" "foreach");
  F->kind = fn_builtin;
  F->data = (void *) blt_foreach;

  strlist_append (&F->args, strdup ("_VARNAME"));

  strlist_append (&F->args, strdup ("_LIST"));

  strlist_append (&F->args, strdup ("_BODY"));

  F = func_new ("#" "include");
  F->kind = fn_builtin;
  F->data = (void *) blt_include;

  strlist_append (&F->args, strdup ("_FILENAME"));

  F = func_new ("#" "replace_suffix");
  F->kind = fn_builtin;
  F->data = (void *) blt_replace_suffix;

  strlist_append (&F->args, strdup ("_RESULT"));

  strlist_append (&F->args, strdup ("_SOURCE"));

  strlist_append (&F->args, strdup ("_NEWSFX"));

  F = func_new ("#" "nth");
  F->kind = fn_builtin;
  F->data = (void *) blt_nth;

  strlist_append (&F->args, strdup ("_RESULT"));

  strlist_append (&F->args, strdup ("_SOURCE"));

  strlist_append (&F->args, strdup ("_INDEX"));

  F = func_new ("#" "command");
  F->kind = fn_builtin;
  F->data = (void *) blt_command;

  strlist_append (&F->args, strdup ("_BODY"));

  F = func_new ("#" "modify");
  F->kind = fn_builtin;
  F->data = (void *) blt_modify;

  strlist_append (&F->args, strdup ("_TARGETS"));

  strlist_append (&F->args, strdup ("_BODY"));

  cmd_init ();
  modtimes_init ();
}

char *get_current_dir_name ();

static void
get_wd ()
{

  cwd = get_current_dir_name ();
  var_create ("$CWD", cwd);
  var_create ("$HERE", "");
}

static sstack_t *sstack_new ()
{
  sstack_t *L;
  L = malloc (sizeof (*L));
  L->nelts = 0;
  L->size = 0;
  L->elts = 0;
  return L;
}

static void sstack_init (sstack_t * L)
{
  L->nelts = 0;
  L->size = 0;
  L->elts = 0;
}

static char *sstack_pop (sstack_t * L)
{
  char *R;
  L->nelts--;
  R = L->elts[L->nelts];
  return R;
}

static void sstack_push (sstack_t * L, char *d)
{
  if (L->nelts == L->size)
    {
      if (!L->size)
	{
	  L->size = 20;
	  L->elts = calloc (L->size, sizeof (char *));
	}
      else
	{
	  L->size += L->size / 2;
	  L->elts = realloc (L->elts, L->size * sizeof (char *));
	}
    }
  L->elts[L->nelts] = d;
  L->nelts++;
}

static sstack_t *sstack_destroy (sstack_t * L)
{
  if (L->size)
    free (L->elts);
  L->size = 0;
  return L;
}

static int sstack_isempty (sstack_t * L)
{
  return L->nelts == 0;
}

#define LCURLY '{'
#define RCURLY '}'

int
ipret_block (char *fn, char *input)
{
  int state;
  sstack_t *stack;
  int Z;
  char *t_begin;
  int ttype;
  char *val;
  char *str;

  stack = sstack_new ();
  state = 0;

  while (1)
    {
      {
	typeof (state) _X34 = state;
	typeof (*input) _Y34 = *input;
	enum
	{
	  _sw_case_34_default,

	  _sw_case_34_35,

	  _sw_case_34_36,

	  _sw_case_34_37,

	  _sw_case_34_38,

	  _sw_case_34_40,

	  _sw_case_34_41,

	  _sw_case_34_43,

	  _sw_case_34_45,

	  _sw_case_34_47,

	  _sw_case_34_48,

	  _sw_case_34_49,

	  _sw_case_34_50,

	  _sw_case_34_51,

	  _sw_case_34_52,

	  _sw_case_34_53,

	  _sw_case_34_54,

	  _sw_case_34_55,

	} _sw_var_34 = _sw_case_34_default;

	if (0)
	  {

	  }
	else if (_X34 == (0) && _Y34 == (0))
	  {

	    _sw_var_34 = _sw_case_34_35;

	  }
	else if (_X34 == (0) && _Y34 >= (1) && _Y34 <= (32))
	  {

	    _sw_var_34 = _sw_case_34_36;

	  }
	else if (_X34 == (0) && _Y34 == (127))
	  {

	    _sw_var_34 = _sw_case_34_37;

	  }
	else if (_X34 == (0) && _Y34 == (LCURLY))
	  {

	    _sw_var_34 = _sw_case_34_38;

	  }
	else if (_X34 == (0) && _Y34 == (RCURLY))
	  {

	    _sw_var_34 = _sw_case_34_40;

	  }
	else if (_X34 == (0) && _Y34 == ('$'))
	  {

	    _sw_var_34 = _sw_case_34_41;

	  }
	else if (_X34 == (0) && _Y34 == ('#'))
	  {

	    _sw_var_34 = _sw_case_34_43;

	  }
	else if (_X34 == ('C') && _Y34 == (LCURLY))
	  {

	    _sw_var_34 = _sw_case_34_47;

	  }
	else if (_X34 == ('C') && _Y34 == (RCURLY))
	  {

	    _sw_var_34 = _sw_case_34_48;

	  }
	else if (_X34 == ('C') && _Y34 == (0))
	  {

	    _sw_var_34 = _sw_case_34_49;

	  }
	else if (_X34 == ('W') && _Y34 >= (1) && _Y34 <= (32))
	  {

	    _sw_var_34 = _sw_case_34_51;

	  }
	else if (_X34 == ('W') && _Y34 == (RCURLY))
	  {

	    _sw_var_34 = _sw_case_34_52;

	  }
	else if (_X34 == ('W') && _Y34 == (LCURLY))
	  {

	    _sw_var_34 = _sw_case_34_53;

	  }
	else if (_X34 == (0))
	  {

	    _sw_var_34 = _sw_case_34_45;

	  }
	else if (_X34 == ('C'))
	  {

	    _sw_var_34 = _sw_case_34_50;

	  }
	else if (_X34 == ('W'))
	  {

	    _sw_var_34 = _sw_case_34_54;

	  }
	else if (_Y34 == (0))
	  {

	    _sw_var_34 = _sw_case_34_55;

	  }
	switch (_sw_var_34)
	  {

	  case _sw_case_34_35:

	    goto end;

	  case _sw_case_34_36:

	  case _sw_case_34_37:

	    input++;
	    break;

	  case _sw_case_34_38:

	    Z = 1;
	    t_begin = input;
	    input++;
	    state = 'C';
	    break;

	  case _sw_case_34_40:

	    do_error (fn, input, "unmatched curly brace");
	    break;

	  case _sw_case_34_41:

	    ttype = 'V';
	    t_begin = input;
	    input++;
	    state = 'W';
	    break;

	  case _sw_case_34_43:

	    ttype = 'F';
	    t_begin = input;
	    input++;
	    state = 'W';
	    break;

	  case _sw_case_34_45:

	    ttype = 'S';
	    t_begin = input;
	    input++;
	    state = 'W';
	    break;

	  case _sw_case_34_47:

	    Z++;
	    input++;
	    break;

	  case _sw_case_34_48:

	    input++;
	    Z--;
	    if (Z == 0)
	      {
		t_begin++;
		sstack_push (stack, make_str (t_begin, input - t_begin - 1));
		state = 0;
	      }
	    break;

	  case _sw_case_34_49:

	    do_error (fn, 0, "unexpected EOF in string");
	    break;

	  case _sw_case_34_50:

	    input++;
	    break;

	  case _sw_case_34_51:

	  case _sw_case_34_52:

	  case _sw_case_34_53:

	    str = make_str (t_begin, input - t_begin);
	    switch (ttype)
	      {
	      case 'S':
		sstack_push (stack, str);
		str = 0;
		break;
	      case 'F':
		call_function (str, stack);
		break;
	      case 'V':
		val = var_get (str);
		if (val)
		  {
		    sstack_push (stack, strdup (val));
		  }
		else
		  {
		    sstack_push (stack, str);
		    str = 0;
		  }
		break;
	      }
	    if (str)
	      free (str);
	    state = 0;
	    break;

	  case _sw_case_34_54:

	    input++;
	    break;

	  case _sw_case_34_55:

	    do_error (fn, 0, "unexpected EOF in statement");
	    break;

	  default:

	    break;
	  }
      }

    }
end:
  empty_stack (stack);
  sstack_destroy (stack);
  free (stack);
  return 0;
}

/* input: " ...b/c  "  . output:  " ...b/" */
char *
fs_dirname (char *x)
{
  char *S;
  char *d;
  int len;
  S = strrchr (x, '/');
  if (S == NULL)
    return 0;
  len = S - x + 1;
  d = malloc (sizeof (char) * (len + 1));
  memcpy (d, x, len * sizeof (char));
  d[len] = 0;
  return d;
}

char *
fs_normalize (char *dir)
{
  char *x;

  while ((x = strstr (dir, "//")))
    memmove (x, x + 1, (strlen (x + 1) + 1) * sizeof (char));

  while ((x = strstr (dir, "/./")))
    memmove (x, x + 2, (strlen (x + 2) + 1) * sizeof (char));

  while ((x = strstr (dir, "/../")))
    {
      if (x == dir)
	{
	  memmove (dir, dir + 3, (strlen (x + 3) + 1) * sizeof (char));
	}
      else
	{
	  char *up;
	  for (up = x - 1; *up != '/'; up--)
	    ;
	  memmove (up, x + 3, (strlen (x + 3) + 1) * sizeof (char));
	}
    }
  return dir;
}

static char *
file_read_all (char *fn)
{
  size_t L;
  struct stat sb;
  FILE *f;
  char *buf = 0;
  int total;
  if (stat (fn, &sb))
    return NULL;
  f = fopen (fn, "rb");
  if (!f)
    return NULL;
  L = sb.st_size;
  buf = malloc (L + 1);
  if (!buf)
    goto done;
  total = 0;
  while (total < L)
    {
      size_t r = fread (buf + total, 1, L - total, f);
      if (!r)
	{
	  free (buf);
	  buf = 0;
	  break;
	}
      total += r;
    }
  buf[L] = 0;
done:
  fclose (f);

  return buf;
}

size_t strnlen (const char *, size_t);

/* This source does not define an output file.
      You need to define it using library or
      program directives in another file 
      Probably it`s best to put this in its
      own file since there are a couple of
      #defines which can affect the operation
      of the other code if placed in a file
      with something that uses the defined
      symbols for other purposes */

/* 
 *  linux/lib/vsprintf.c
 *
 *  Copyright (C) 1991, 1992  Linus Torvalds
 */

/* vsprintf.c -- Lars Wirzenius & Linus Torvalds. */
/*
 * Wirzenius wrote this portably, Torvalds fucked it up :-)
 */

/* 
 * Fri Jul 13 2001 Crutcher Dunnavant
	<crutcher+kernel@datastacks.com>
 * - changed to provide snprintf and vsnprintf functions
 */

/* 20031029  Sukru Cinar 
 * - modified to provide genprintf 
 */

/* 20070205 Sukru Cinar
  * - ported to the .w format 
  */

/* 20090713 Sukru Cinar
 *  - made it possible to include it as an applib library file
 */

static int
skip_atoi (const char **s)
{
  int i = 0;

  while (isdigit (**s))
    i = i * 10 + *((*s)++) - '0';
  return i;
}

#define ZEROPAD	1		/* pad with zero */
#define SIGN	2		/* unsigned/signed long */
#define PLUS	4		/* show plus */
#define SPACE	8		/* space if plus */
#define LEFT	16		/* left justified */
#define SPECIAL	32		/* 0 x */
#define LARGE	64		/* use 'ABCDEF' instead of 'abcdef' */

#define WRITE(x,y) do {\
	if (write) \
		(*write)(arg, x, y);\
	written+= y;\
} while(0)

static char zerochar = '0', spacechar = ' ', percentchar = '%';
#ifdef do_div
#undef do_div
#endif

static int
do_div (long long int *x, int y)
{
  int ret = *x % y;
  *x /= y;
  return ret;
}

static size_t
number (void (*write) (void *, const char *, size_t), void *arg,
	long long num, int base, int size, int precision, int type)
{
  size_t written = 0;
  char c, sign, tmp[66];
  const char *digits;
  const char small_digits[] = "0123456789abcdefghijklmnopqrstuvwxyz";
  const char large_digits[] = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
  int i;

  digits = (type & LARGE) ? large_digits : small_digits;
  if (type & LEFT)
    type &= ~ZEROPAD;
  if (base < 2 || base > 36)
    return 0;
  c = (type & ZEROPAD) ? '0' : ' ';
  sign = 0;
  if (type & SIGN)
    {
      if (num < 0)
	{
	  sign = '-';
	  num = -num;
	  size--;
	}
      else if (type & PLUS)
	{
	  sign = '+';
	  size--;
	}
      else if (type & SPACE)
	{
	  sign = ' ';
	  size--;
	}
    }
  if (type & SPECIAL)
    {
      if (base == 16)
	size -= 2;
      else if (base == 8)
	size--;
    }
  i = 0;
  if (num == 0)
    tmp[i++] = '0';
  else
    while (num != 0)
      tmp[i++] = digits[do_div (&num, base)];
  if (i > precision)
    precision = i;
  size -= precision;
  if (!(type & (ZEROPAD + LEFT)))
    {
      while (size-- > 0)
	{
	  WRITE (&spacechar, 1);
	}
    }
  if (sign)
    {
      WRITE (&sign, 1);
    }
  if (type & SPECIAL)
    {
      if (base == 8)
	{
	  WRITE (&zerochar, 1);
	}
      else if (base == 16)
	{
	  WRITE (&zerochar, 1);
	  WRITE (digits + 33, 1);
	}
    }
  if (!(type & LEFT))
    {
      while (size-- > 0)
	{
	  WRITE (&c, 1);
	}
    }
  while (i < precision--)
    {
      WRITE (&zerochar, 1);
    }
  while (i-- > 0)
    {
      WRITE (tmp + i, 1);
    }
  while (size-- > 0)
    {
      WRITE (&spacechar, 1);
    }
  return written;
}

/**
* vsnprintf - Format a string and place it in a buffer
* @buf: The buffer to place the result into
* @size: The size of the buffer, including the trailing null space
* @fmt: The format string to use
* @args: Arguments for the format string
*
* Call this function if you are already dealing with a va_list.
* You probably want snprintf instead.
*/
size_t
vgenprintf (void (*write) (void *arg, const char *buf, size_t len), void *arg,
	    const char *fmt, va_list args)
{
  size_t written = 0;
  int len;
  unsigned long long num;
  int base;
  char c;
  const char *s;
  int eno = errno;

  int flags;			/* flags to number() */

  int field_width;		/* width of output field */
  int precision;		/* min. # of digits for integers; max
				   number of chars for from string */
  int qualifier;		/* 'h', 'l', or 'L' for integer fields */
  /* 'z' support added 23/7/1999 S.H.    */
  /* 'z' changed to 'Z' --davidm 1/25/99 */

  for (; *fmt; ++fmt)
    {
      if (*fmt != '%')
	{
	  WRITE (fmt, 1);
	  continue;
	}

      /* process flags */
      flags = 0;
    repeat:
      ++fmt;			/* this also skips first '%' */
      switch (*fmt)
	{
	case '-':
	  flags |= LEFT;
	  goto repeat;
	case '+':
	  flags |= PLUS;
	  goto repeat;
	case ' ':
	  flags |= SPACE;
	  goto repeat;
	case '#':
	  flags |= SPECIAL;
	  goto repeat;
	case '0':
	  flags |= ZEROPAD;
	  goto repeat;
	}

      /* get field width */
      field_width = -1;
      if (isdigit (*fmt))
	field_width = skip_atoi (&fmt);
      else if (*fmt == '*')
	{
	  ++fmt;
	  /* it`s the next argument */
	  field_width = va_arg (args, int);
	  if (field_width < 0)
	    {
	      field_width = -field_width;
	      flags |= LEFT;
	    }
	}

      /* get the precision */
      precision = -1;
      if (*fmt == '.')
	{
	  ++fmt;
	  if (isdigit (*fmt))
	    precision = skip_atoi (&fmt);
	  else if (*fmt == '*')
	    {
	      ++fmt;
	      /* it`s the next argument */
	      precision = va_arg (args, int);
	    }
	  if (precision < 0)
	    precision = 0;
	}

      /* get the conversion qualifier */
      qualifier = -1;
      if (*fmt == 'h' || *fmt == 'l' || *fmt == 'L' || *fmt == 'Z'
	  || *fmt == 'r')
	{
	  qualifier = *fmt;
	  ++fmt;
	  if (qualifier == 'l' && *fmt == 'l')
	    {
	      qualifier = 'L';
	      ++fmt;
	    }
	}

      /* default base */
      base = 10;

      switch (*fmt)
	{
	case 'c':
	  if (!(flags & LEFT))
	    {
	      while (--field_width > 0)
		{
		  WRITE (&spacechar, 1);
		}
	    }
	  c = (unsigned char) va_arg (args, int);
	  WRITE (&c, 1);
	  while (--field_width > 0)
	    {
	      WRITE (&spacechar, 1);
	    }
	  continue;

	case 'R':
	case 's':
	  if (*fmt == 's')
	    s = va_arg (args, char *);
	  else
	    s = strerror (eno);
	  if (!s)
	    s = "<NULL>";

	  len = strnlen (s, precision);

	  if (!(flags & LEFT))
	    {
	      while (len < field_width--)
		{
		  WRITE (&spacechar, 1);
		}
	    }
	  WRITE (s, len);
	  while (len < field_width--)
	    {
	      WRITE (&spacechar, 1);
	    }
	  continue;
	case 'p':
	  if (field_width == -1)
	    {
	      field_width = 2 * sizeof (void *);
	      flags |= ZEROPAD;
	    }
	  written += number (write, arg,
			     (unsigned long) va_arg (args, void *),
			     16, field_width, precision, flags);
	  continue;

	case 'n':
	  /* FIXME:
	   * What does C99 say about the overflow case here? */
	  if (qualifier == 'l')
	    {
	      long *ip = va_arg (args, long *);
	      *ip = written;
	    }
	  else if (qualifier == 'Z')
	    {
	      size_t *ip = va_arg (args, size_t *);
	      *ip = written;
	    }
	  else
	    {
	      int *ip = va_arg (args, int *);
	      *ip = written;
	    }
	  continue;

	case '%':
	  WRITE (&percentchar, 1);
	  continue;

	  /* integer number formats - set up the flags and "break" */
	case 'o':
	  base = 8;
	  break;

	case 'X':
	  flags |= LARGE;
	case 'x':
	  base = 16;
	  break;

	case 'd':
	case 'i':
	  flags |= SIGN;
	case 'u':
	  break;

	default:
	  WRITE (&percentchar, 1);
	  if (*fmt)
	    {
	      WRITE (fmt, 1);
	    }
	  else
	    {
	      --fmt;
	    }
	  continue;
	}
      if (qualifier == 'L')
	num = va_arg (args, long long);
      else if (qualifier == 'l')
	{
	  num = va_arg (args, unsigned long);
	  if (flags & SIGN)
	    num = (signed long) num;
	}
      else if (qualifier == 'Z')
	{
	  num = va_arg (args, size_t);
	}
      else if (qualifier == 'h')
	{
	  num = (unsigned short) va_arg (args, int);
	  if (flags & SIGN)
	    num = (signed short) num;
	}
      else if (qualifier == 'r')
	{
	  num = eno;
	}
      else
	{
	  num = va_arg (args, unsigned int);
	  if (flags & SIGN)
	    num = (signed int) num;
	}
      written += number (write, arg,
			 num, base, field_width, precision, flags);
    }
/*	WRITE(&nullchar,1);*/
  return written;
}

size_t
genprintf (void (*write) (void *arg, const char *buf, size_t len),
	   void *arg, const char *fmt, ...)
{
  va_list ap;
  size_t ret;
  va_start (ap, fmt);
  ret = vgenprintf (write, arg, fmt, ap);
  va_end (ap);
  return ret;
}

size_t
fdprintf (int fd, const char *fmt, ...)
{
  va_list ap;
  size_t ret;
  va_start (ap, fmt);
  ret = vgenprintf ((void *) write, (void *) (uint64_t) fd, fmt, ap);
  va_end (ap);
  return ret;
}

static void
write_buf (char **x, const char *b, size_t len)
{
  memcpy (*x, b, len);
  *x += len;
}

char *
vmprintf (const char *fmt, va_list ap)
{
  va_list ap2;
  size_t size;
  char *ret, *x;
  int eno = errno;
  va_copy (ap2, ap);
  size = vgenprintf (0, 0, fmt, ap2);
  va_end (ap2);
  x = ret = malloc (size + 1);
  if (ret)
    {
      errno = eno;
      vgenprintf ((void *) write_buf, (void *) &x, fmt, ap);
      ret[size] = 0;
    }
  return ret;
}

size_t
vnprintf (const char *fmt, va_list ap)
{
  return vgenprintf (0, 0, fmt, ap);
}

char *
mprintf (const char *fmt, ...)
{
  va_list ap;
  char *ret;
  va_start (ap, fmt);
  ret = vmprintf (fmt, ap);
  va_end (ap);
  return ret;
}

static void
do_error (char *fn, char *ref, char *msg)
{
  fprintf (stderr, "%s: %s\n", fn, msg);
  exit (1);
}

static char *
make_str (char *b, int L)
{
  char *R;
  R = malloc (L + 1);
  memcpy (R, b, L);
  R[L] = 0;
  return R;
}

int ipret_file (char *dir, char *fn)
{

  char *input;
  char *here_old;
  int ret;

  if (fn[0] != '/')
    fn = fs_normalize (mprintf ("%s/%s", dir, fn));
  else
    fn = fs_normalize (strdup (fn));
  input = file_read_all (fn);
  if (!input)
    exit (fprintf (stderr, "can not read file %s: %s\n",
		   fn, strerror (errno)));
  here_old = strdup (var_get ("$HERE"));
  var_set ("$HERE", fs_dirname (fn));
  ret = ipret_block (fn, input);
  var_set ("$HERE", here_old);
  return ret;
}

static void call_function (char *name, sstack_t * stack)
{
  func_t *F;

  F = func_get (name);
  if (!F)
    exit (fprintf (stderr, "can not find function %s\n", name));

  if (F->kind == fn_user)
    expand_args (stack);

  frame_enter ();
  bind_args (&F->args, stack);

  if (F->kind == fn_user)
    {
      ipret_block ("<internal>", F->data);
    }
  else
    {
      void (*func) ();
      func = F->data;
      func ();
    }

  frame_leave ();
  empty_stack (stack);
}

static void bind_args (strlist_t * arglist, sstack_t * stack)
{
  int i;
  i = 0;
  {
    typeof ((*arglist).head.next) N65, T65;
    for (T65 = (*arglist).head.next; T65 != &((*arglist).head); T65 = N65)
      {
	typeof (T65->data) argname;
	argname = T65->data;
	N65 = T65->next;

	char *val;
	if (i >= stack->nelts)
	  val = "";
	else
	  val = stack->elts[i];
	var_create (argname, val);
	i++;

      }
  }

}

static void
expand_args (sstack_t * stack)
{
  int i;
  for (i = 0; i < stack->nelts; i++)
    {
      char *X, *Y;
      X = stack->elts[i];
      Y = expand_variables_in_str (X);
      if (Y != X)
	{
	  free (stack->elts[i]);
	  stack->elts[i] = Y;
	}
    }
}

static void charbuffer_init (charbuffer_t * B)
{
  B->first = malloc (sizeof (*B->first));
  B->first->next = 0;
  B->first->len = 0;
  B->last = B->first;
}

static charbuffer_t *charbuffer_new ()
{
  charbuffer_t *B;
  B = malloc (sizeof (*B));

  charbuffer_init (B);
  return B;
}

static void charbuffer_append (charbuffer_t * B, char D)
{
  struct charbuffer_t_node *L;
  L = B->last;
  if (L->len == 500)
    {
      L = malloc (sizeof (*L));
      L->len = 0;
      L->next = 0;
      B->last->next = L;
      B->last = L;
    }
  L->data[L->len] = D;
  L->len++;
}

static char *charbuffer_collect (charbuffer_t * B, int *size)
{
  struct charbuffer_t_node *L;
  int C;
  char *R;

  {
    C = 0;
    for (L = B->first; L; L = L->next)
      C += L->len;
  }

  if (size)
    *size = C;
  if (C)
    {
      R = malloc (C * sizeof (*R));

      {
	C = 0;
	for (L = B->first; L; L = L->next)
	  {
	    int i;
	    for (i = 0; i < L->len; i++)
	      R[C + i] = L->data[i];
	    C += L->len;
	  }
      }

    }
  else
    R = 0;
  return R;
}

static char *charbuffer_collectd (charbuffer_t * B, int *size)
{
  char *R;
  R = charbuffer_collect (B, size);

  charbuffer_destroy (B);
  return R;
}

static char *charbuffer_collectda (charbuffer_t * B, int *size)
{
  char *R;
  R = charbuffer_collect (B, size);

  charbuffer_destroya (B);
  return R;
}

static void charbuffer_destroy (charbuffer_t * B)
{
  struct charbuffer_t_node *L, *N;

  for (L = B->first; L; L = N)
    {
      N = L->next;
      free (L);
    }
  B->first = B->last = 0;
}

static void charbuffer_destroya (charbuffer_t * B)
{

  charbuffer_destroy (B);
  free (B);
}

static char *expand_variables_in_str (char *input)
{
  charbuffer_t *buffer;
  int size;

  if (!strchr (input, '$'))
    return input;

  buffer = charbuffer_new ();

  while (*input)
    {
      char *begin;
      char *s;
      char *val;
      if (*input != '$')
	{
	  charbuffer_append (buffer, input[0]);
	  input++;
	  continue;
	}
      begin = input;
      while (*input
	     && *input != 127 && (*input < 0 || *input > 32)
	     && *input != LCURLY && *input != RCURLY)
	{
	  input++;
	}
      s = make_str (begin, input - begin);
      val = var_get (s);
      free (s);
      if (val)
	{
	  for (s = val; *s; s++)
	    charbuffer_append (buffer, s[0]);
	}
      else
	{
	  while (begin != input)
	    {
	      charbuffer_append (buffer, begin[0]);
	      begin++;
	    }
	}
    }
  charbuffer_append (buffer, 0);

  return charbuffer_collectda (buffer, &size);
}

static void
empty_stack (sstack_t * stack)
{
  while (!sstack_isempty (stack))
    {
      char *S;
      S = sstack_pop (stack);
      free (S);
    }
  stack->nelts = 0;
}

static void
blt_print ()
{
  char *V;
  V = var_get ("STR");

  printf ("PRINT>%s<\n", expand_variables_in_str (V));
}

static void
blt_comment ()
{
}

time_t
get_modtime (char *fn)
{
  time_t T;
  T = modtime (fn);
  if (!T)
    exit (fprintf (stderr, "jj: can not get modtime for file %s\n", fn));
  return T;
}

time_t
get_modtime_weak (char *fn)
{
  return modtime (fn);
}

static time_t
modtime (char *fn)
{
  mtime_entry_t *R;
  mtime_entry_t C;
  struct stat sbuf;

  C.fn = fn;
  R = mtimecache_find (modtimes, &C);
  if (R)
    return R->mtime;

  if (stat (fn, &sbuf))
    return 0;

  R = (typeof (R)) calloc (1, sizeof (R[0]));

  R->fn = strdup (fn);
  R->mtime = sbuf.st_mtime;
  mtimecache_insert (modtimes, R);
  return R->mtime;
}

static void mtimecache_init (mtimecache_t * t)
{
  t->root = 0;
}

static mtime_entry_t *mtimecache_destroy (mtimecache_t * t)
{

  struct mtimecache_t_NODE *N;
  mtime_entry_t *retval;

  if (!t->root)
    /* FIXME: this should be configurable, ie. 
       the return value for unknowns should be
       variable depending on the type. for instance,
       maybe we want to return -1 for a tree of  integers.
       as it is, the tree is usable for pointers only */
    return NULL;

  N = mtimecache_t_destroy_one_node (t->root, &t->root);
  retval = N->data;
  free (N);
  return retval;
}

static mtime_entry_t *mtimecache_find (mtimecache_t * t, mtime_entry_t * key)
{
  struct mtimecache_t_NODE *n = t->root;
  while (n)
    {
      int u;
      u = mtimecache_t_compare (key, n->data);
      if (u == 0)
	return n->data;
      else if (u < 0)
	n = n->left;
      else
	n = n->right;
    }
  /* see FIXME above */
  return NULL;
}

static int mtimecache_insert (mtimecache_t * t, mtime_entry_t * data)
{
  if (mtimecache_t_find_node (t->root, data))
    {
      return 1;
    }
  else
    {
      struct mtimecache_t_NODE *node;
      node = (struct mtimecache_t_NODE *) malloc (sizeof (*node));
      node->height = 1;
      node->left = node->right = 0;
      node->data = data;
      t->root = mtimecache_t_insert_node (t->root, node);
      return 0;
    }
}

static mtime_entry_t *mtimecache_remove
  (mtimecache_t * t, mtime_entry_t * key)
{
  struct mtimecache_t_NODE *node;
  mtime_entry_t *retval;
  retval = 0;
  node = mtimecache_t_find_node (t->root, key);
  if (node)
    {
      t->root = mtimecache_t_remove_node (t->root, node);
      retval = node->data;
      free (node);
    }
  return retval;
}

static struct mtimecache_t_NODE *mtimecache_t_insert_node
  (struct mtimecache_t_NODE *t, struct mtimecache_t_NODE *n)
{
  int u;
  if (!t)
    return n;
  u = mtimecache_t_compare (n->data, t->data);
  if (u < 0)
    t->left = mtimecache_t_insert_node (t->left, n);
  else
    t->right = mtimecache_t_insert_node (t->right, n);
  return mtimecache_t_balance (t);
}

static int inline
mtimecache_t_height (struct mtimecache_t_NODE *x)
{
  return x ? x->height : 0;
}

static struct mtimecache_t_NODE *
mtimecache_t_balance (struct mtimecache_t_NODE *t)
{
  int u;
  mtimecache_t_calc_height (t);
  u = mtimecache_t_height (t->left) - mtimecache_t_height (t->right);
  if (u > 1)
    return mtimecache_t_rotate_right (t);
  else if (u < -1)
    return mtimecache_t_rotate_left (t);
  else
    return t;
}

static struct mtimecache_t_NODE *mtimecache_t_remove_node
  (struct mtimecache_t_NODE *t, struct mtimecache_t_NODE *node)
{
  int u;
  u = mtimecache_t_compare (node->data, t->data);
  if (u < 0)
    t->left = mtimecache_t_remove_node (t->left, node);
  else if (u > 0)
    t->right = mtimecache_t_remove_node (t->right, node);
  else
    {
      if (!t->right || !t->left)
	{
	  if (t->right)
	    return t->right;
	  else
	    return t->left;
	}
      else
	{
	  struct mtimecache_t_NODE *p;
	  if (t->left->height > t->right->height)
	    p = mtimecache_t_remove_max (t->left, &t->left);
	  else
	    p = mtimecache_t_remove_min (t->right, &t->right);
	  p->left = t->left;
	  p->right = t->right;
	  p->height = 1;
	  t = p;
	}
    }
  return mtimecache_t_balance (t);
}

static struct mtimecache_t_NODE *
mtimecache_t_rotate_right (struct mtimecache_t_NODE *g)
{
  struct mtimecache_t_NODE *f, *e;
  f = g->left;
  e = f->right;
  f->right = g;
  g->left = e;
  mtimecache_t_calc_height (g);
  mtimecache_t_calc_height (f);
  return f;
}

static struct mtimecache_t_NODE *
mtimecache_t_rotate_left (struct mtimecache_t_NODE *g)
{
  struct mtimecache_t_NODE *f, *e;
  f = g->right;
  e = f->left;
  f->left = g;
  g->right = e;
  mtimecache_t_calc_height (g);
  mtimecache_t_calc_height (f);
  return f;
}

static struct mtimecache_t_NODE *mtimecache_t_remove_max
  (struct mtimecache_t_NODE *t, struct mtimecache_t_NODE **pl)
{
  if (t->right)
    {
      struct mtimecache_t_NODE *z;
      z = mtimecache_t_remove_max (t->right, &t->right);
      mtimecache_t_calc_height (t);
      return z;
    }
  *pl = t->left;
  return t;
}

static struct mtimecache_t_NODE *mtimecache_t_remove_min
  (struct mtimecache_t_NODE *t, struct mtimecache_t_NODE **pl)
{
  if (t->left)
    {
      struct mtimecache_t_NODE *z;
      z = mtimecache_t_remove_min (t->left, &t->left);
      mtimecache_t_calc_height (t);
      return z;
    }
  *pl = t->right;
  return t;
}

static void
mtimecache_t_calc_height (struct mtimecache_t_NODE *t)
{
  int a, b;
  a = mtimecache_t_height (t->left) + 1;
  b = mtimecache_t_height (t->right) + 1;
  if (a > b)
    t->height = a;
  else
    t->height = b;
}

static struct mtimecache_t_NODE *mtimecache_t_destroy_one_node
  (struct mtimecache_t_NODE *node, struct mtimecache_t_NODE **plink)
{
  if (node->left)
    return mtimecache_t_destroy_one_node (node->left, &node->left);
  else if (node->right)
    return mtimecache_t_destroy_one_node (node->right, &node->right);
  *plink = 0;
  return node;
}

static int
mtimecache_t_compare (mtime_entry_t * X1, mtime_entry_t * X2)
{

  return strcmp (X1->fn, X2->fn);

}

static struct mtimecache_t_NODE *
mtimecache_t_find_node (struct mtimecache_t_NODE *node, mtime_entry_t * key)
{
  int cmp;
  if (!node)
    return NULL;
  cmp = mtimecache_t_compare (key, node->data);
  if (cmp < 0)
    return mtimecache_t_find_node (node->left, key);
  else if (cmp > 0)
    return mtimecache_t_find_node (node->right, key);
  else
    return node;
}

static void
modtimes_init ()
{

  modtimes = (typeof (modtimes)) calloc (1, sizeof (modtimes[0]));

  mtimecache_init (modtimes);
}

static time_t
get_modtime_force (char *fn)
{
  mtime_entry_t *R;
  mtime_entry_t C;
  struct stat sbuf;

  C.fn = fn;
  R = mtimecache_find (modtimes, &C);
  if (R)
    {
      mtimecache_remove (modtimes, R);
      free (R->fn);
      free (R);
    }

  if (stat (fn, &sbuf))
    exit (fprintf (stderr, "jj: can not get modtime for file %s\n", fn));

  R = (typeof (R)) calloc (1, sizeof (R[0]));

  R->fn = strdup (fn);
  R->mtime = sbuf.st_mtime;
  mtimecache_insert (modtimes, R);
  return R->mtime;
}

static pr_t head = { &head, &head };

/*
	one-shot execution: 
		execute the program with the given input string, collect output and error streams and return
	monitored executon:
		start the program
		enable the user to read/write the output/error/input streams
		enable the user to kill/stop the program
		let the user know whether the program is still alive or not
*/

int
proc_kill (int id, int sig)
{
  if (kill (id, sig))
    return -errno;
  return 0;
}

static void
close_force (int fd)
{
  if (fd != -1)
    while (close (fd) && errno == EINTR)
      ;
}

static void
close_sockets (pr_t * p)
{
  int i;
  for (i = 0; i < 6; i++)
    {
      close_force (p->fds[i]);
      p->fds[i] = -1;
    }
}

/* FIXME: in case of errors, put a descriptive text into the error stream
          mini-shell is a good name for this purpose
*/

static void
child (pr_t * p, char *fn, char **argv, int opts)
{
  int ret = 127;

  if (opts & PROC_INP)
    {
      while (dup2 (p->fds[0], 0) < 0)
	if (errno != EINTR)
	  goto duperr;
      close_force (p->fds[1]);
    }
  ret--;

  if (opts & PROC_OUTP)
    {
      while (dup2 (p->fds[3], 1) < 0)
	if (errno != EINTR)
	  goto duperr;
      close_force (p->fds[2]);
    }
  ret--;

  if (opts & PROC_ERR)
    {
      while (dup2 (p->fds[5], 2) < 0)
	if (errno != EINTR)
	  goto duperr;
      close_force (p->fds[4]);
    }
  ret--;

  execvp (fn, argv);
duperr:
  exit (ret);
}

static pr_t *
find (int pid)
{
  pr_t *p;
  for (p = head.next; p != &head; p = p->next)
    if (p->pid == pid)
      return p;
  return NULL;
}

static char *
code_to_str (int code)
{
  switch (code)
    {
    case CLD_EXITED:
      return "exit";
    case CLD_KILLED:
      return "killed";
    case CLD_DUMPED:
      return "dumped";
    }
  return "unknown";
}

static void
child_sig (int sno, siginfo_t *si, void *dummy)
{
  int pid = si->si_pid;
  int status = si->si_status;
  int code = si->si_code;
  pr_t *p;
  p = find (pid);
  if (!p)
    return;
  switch (code)
    {
    case CLD_EXITED:
    case CLD_KILLED:
    case CLD_DUMPED:
      p->status = PROC_DEAD;
      p->ecode = code;
      p->earg = status;
#ifdef proc_self_test
      printf ("child exit: code= %d (%s) arg= %d\n", code, code_to_str (code),
	      status);
      fflush (0);
#endif
      break;
    case CLD_TRAPPED:
    case CLD_STOPPED:
      p->status = PROC_STOPPED;
      break;
    case CLD_CONTINUED:
      p->status = PROC_RUNNING;
      break;
    }
}

static void
install_handler ()
{
  struct sigaction sa;
  if (sig_installed)
    return;
  sa.sa_sigaction = child_sig;
  sigemptyset (&sa.sa_mask);
  sa.sa_flags = SA_SIGINFO;
  sa.sa_restorer = 0;
  while (sigaction (SIGCHLD, &sa, &old_sa) && errno == EINTR)
    ;
  sig_installed = 1;
}

static void
remove_node (pr_t * p)
{
  p->prev->next = p->next;
  p->next->prev = p->prev;
  free (p);
}

static void
close_socks_main (pr_t * p, int opts)
{
  if (opts & PROC_INP)
    close_force (p->fds[0]);
  if (opts & PROC_OUTP)
    close_force (p->fds[3]);
  if (opts & PROC_ERR)
    close_force (p->fds[5]);
  p->fds[0] = -1;
  p->fds[3] = -1;
  p->fds[5] = -1;
}

int
proc_start (char *fn, char **argv, int opts)
{

  int eno;
  pr_t *p;

  int i;

  install_handler ();

  p = malloc (sizeof (*p));
  if (!p)
    return -ENOMEM;
  p->prev = head.prev;
  p->next = &head;
  head.prev->next = p;
  head.prev = p;
  p->status = PROC_RUNNING;

  for (i = 0; i < 6; i++)
    p->fds[i] = -1;

  if (opts & PROC_INP)
    {
      if (pipe (p->fds + 0))
	goto sockerr;
    }

  if (opts & PROC_OUTP)
    {
      if (pipe (p->fds + 2))
	goto sockerr;
    }

  if (opts & PROC_ERR)
    {
      if (pipe (p->fds + 4))
	goto sockerr;
    }

  p->pid = fork ();
  if (p->pid < 0)
    goto sockerr;
  if (p->pid == 0)
    child (p, fn, argv, opts);
  if (0)
    {
      int i;
      for (i = 0; i < 6; i++)
	printf ("fd[%d]= %d\n", i, p->fds[i]);
    }
  close_socks_main (p, opts);
  return p->pid;

sockerr:
  eno = errno;
  close_sockets (p);
  remove_node (p);
  return -eno;
}

static void
interp_status (int s, pr_t * p)
{

  if (WIFEXITED (s))
    {
      p->ecode = CLD_EXITED;
      p->earg = WEXITSTATUS (s);
    }
  else if (WIFSIGNALED (s))
    {
      p->ecode = CLD_DUMPED;
      p->earg = WTERMSIG (s);
    }
  p->status = PROC_DEAD;
#ifdef proc_self_test
  printf ("child exit (wait): code= %d (%s) arg= %d\n", p->ecode,
	  code_to_str (p->ecode), p->earg);
#endif
}

int
proc_end (int id, int *st)
{
  int status;
  pr_t *p;
  int c, a;
  p = find (id);
  if (!p)
    return 0;
  close_sockets (p);
  while (waitpid (id, &status, 0) < 0 && errno == EINTR)
    ;
  if (p->status != PROC_DEAD)
    interp_status (status, p);
  c = p->ecode;
  a = p->earg;
  remove_node (p);
  if (c == CLD_KILLED || c == CLD_DUMPED || (c == CLD_EXITED && a != 0))
    {
      if (st)
	*st = a;
      return c;
    }
  return 0;
}

int
proc_input (int id)
{
  pr_t *p = find (id);
  return p ? p->fds[1] : -ESRCH;
}

int
proc_output (int id)
{
  pr_t *p = find (id);
  return p ? p->fds[2] : -ESRCH;
}

int
proc_error (int id)
{
  pr_t *p = find (id);
  return p ? p->fds[4] : -ESRCH;
}

int
proc_islive (int id)
{
  pr_t *p = find (id);
  return p ? (p->status != PROC_DEAD) : 0;
}

typedef struct buffer
{
  struct buffer *next;
  char data[4088];
  int len;
} buffer_t;

static buffer_t *
do_read (int fd, fd_set * set, buffer_t * tail, int *ende)
{
  int r;
  *ende = 0;
  if (fd != -1 && FD_ISSET (fd, set))
    {
      int l = sizeof (tail->data) - tail->len;
      while (1)
	{
	  r = read (fd, tail->data + tail->len, l);
	  if (r < 0 && errno == EINTR)
	    continue;
	  if (r <= 0)
	    {
	      *ende = 1;
	      return tail;	/* FIXME: think of something */
	    }
	  break;
	}
      tail->len += r;
      if (tail->len == sizeof (tail->data))
	{
	  buffer_t *b = malloc (sizeof (*b));
	  b->len = 0;
	  b->next = 0;
	  tail->next = b;
	  tail = b;
	}
    }
  return tail;
}

static void
collect_buffer (char **d, size_t * l, buffer_t * h)
{
  size_t s = 0;
  char *D;
  buffer_t *p;
  if (!d)
    return;
  for (p = h; p; p = p->next)
    s += p->len;
  D = malloc (s + 1);
  *d = D;
  for (p = h; p; p = p->next)
    {
      memcpy (D, p->data, p->len);
      D += p->len;
    }
  *D = 0;
  p = h->next;
  while (p)
    {
      buffer_t *n = p->next;
      free (p);
      p = n;
    }
  *l = s;
}

static void
add_set (int *max, fd_set * set, int fd)
{
  FD_SET (fd, set);
  if (fd > *max)
    *max = fd;
}

/* one-shot */

int
proc_run (char *fn, char **argv, int *arg, char *inp, size_t inp_l,
	  char **outp, size_t * outp_l, char **err, size_t * err_l)
{
  int input = 0;
  int inp_fd = -1, outp_fd = -1, err_fd = -1;
  int r;
  int opts = 0;
  int ch;
  buffer_t errhead;
  buffer_t outhead;
  buffer_t *errb;
  buffer_t *outb;
  pr_t *p;
  if (inp)
    opts |= PROC_INP;
  if (outp)
    {
      *outp = NULL;
      opts |= PROC_OUTP;
    }
  if (err)
    {
      *err = NULL;
      opts |= PROC_ERR;
    }
  ch = proc_start (fn, argv, opts);
  if (ch < 0)
    return ch;
  if (inp)
    inp_fd = proc_input (ch);
  if (outp)
    outp_fd = proc_output (ch);
  if (err)
    err_fd = proc_error (ch);
  p = find (ch);
  if (!p)
    exit (fprintf (stderr, "internal error in proc library\n"));
  errhead.next = 0;
  outhead.next = 0;
  errhead.len = 0;
  outhead.len = 0;
  errb = &errhead;
  outb = &outhead;
  if (inp_fd != -1)
    input = 1;
  while (p->status != PROC_DEAD
	 && (inp_fd != -1 || err_fd != -1 || outp_fd != -1))
    {
      int e;
      int status;
      fd_set read_fd, write_fd;
      int max = 0;
      struct timeval tm;
      FD_ZERO (&write_fd);
      FD_ZERO (&read_fd);
      if (input)
	add_set (&max, &write_fd, inp_fd);
      if (err_fd != -1)
	add_set (&max, &read_fd, err_fd);
      if (outp_fd != -1)
	add_set (&max, &read_fd, outp_fd);
      tm.tv_sec = 3;
      tm.tv_usec = 0;

      if (waitpid (ch, &status, WNOHANG) == ch)
	{
	  interp_status (status, p);
	  break;
	}
      r =
	select (max + 1, (err_fd != -1 || outp_fd != -1) ? &read_fd : NULL,
		input ? &write_fd : NULL, NULL, NULL);

      if (r < 0)
	{
	  if (errno != EINTR)
	    exit (fprintf (stderr, "select failed: %s\n", strerror (errno)));
	  continue;
	}
      if (r == 0)
	{
	  if (p->status == PROC_DEAD)
	    break;
	  continue;
	}
      outb = do_read (outp_fd, &read_fd, outb, &e);
      if (e)
	outp_fd = -1;
      errb = do_read (err_fd, &read_fd, errb, &e);
      if (e)
	err_fd = -1;
      if (input && FD_ISSET (inp_fd, &write_fd))
	{
	  int r;
	  int l = 1024;
	  if (l > inp_l)
	    l = inp_l;
	  while ((r = write (inp_fd, inp, l)) < 0 && errno == EINTR)
	    ;
	  if (r < 0)
	    break;
	  inp_l -= r;
	  inp += r;
	  if (inp_l == 0)
	    {
	      input = 0;
	      close_force (p->fds[1]);
	      p->fds[1] = -1;
	      inp_fd = -1;
	    }
	}
    }

  while (err_fd != -1 || outp_fd != -1)
    {				/* read the remaining data */
      int e;
      fd_set read_fd;
      int max = 0;
      struct timeval tm;
      FD_ZERO (&read_fd);
      if (err_fd != -1)
	add_set (&max, &read_fd, err_fd);
      if (outp_fd != -1)
	add_set (&max, &read_fd, outp_fd);
      tm.tv_sec = 0;
      tm.tv_usec = 0;

      r = select (max + 1, &read_fd, NULL, NULL, &tm);

      if (r < 0)
	{
	  if (errno != EINTR)
	    exit (fprintf (stderr, "select failed: %s\n", strerror (errno)));
	  continue;
	}
      if (r == 0)
	break;
      outb = do_read (outp_fd, &read_fd, outb, &e);
      if (e)
	outp_fd = -1;
      errb = do_read (err_fd, &read_fd, errb, &e);
      if (e)
	err_fd = -1;
    }

  if (outp)
    collect_buffer (outp, outp_l, &outhead);
  if (errb)
    collect_buffer (err, err_l, &errhead);
  return proc_end (ch, arg);
}

#ifdef proc_self_test

static void
subprog ()
{
  while (1)
    {
      int a, b;
      scanf ("%d%d", &a, &b);
      if (a == 0 && b == 0)
	break;
      printf ("%d+%d=%d\n", a, b, a + b);
      fflush (0);
    }
}

static void
transfer (int in, int out)
{
  int r;
  char buf[4096];
  int L;
  do
    {
      L = read (in, buf, sizeof (buf));
      if (L == 0)
	return;
      else if (L < 0 && errno != EINTR)
	return;
    }
  while (L <= 0);

  r = 0;
  while (r < L)
    {
      int l;
      l = write (out, buf + r, L - r);
      if (l < 0 && errno == EINTR)
	continue;
      if (l == 0)
	break;
      r += l;
    }
}

static void
test (char **argv)
{
  int ch;
  char *fka[3];
  int i = 0;
  int inp;
  int outp;
  fka[i++] = argv[0];
  fka[i++] = "-s";
  fka[i++] = 0;
  ch = proc_start (fka[0], fka, PROC_INP | PROC_OUTP);
  if (ch < 0)
    exit (fprintf
	  (stderr, "could not start sub process: %s\n", strerror (-ch)));
  inp = proc_input (ch);
  outp = proc_output (ch);
  while (proc_islive (ch))
    {
      int r;
      fd_set readfs;
      FD_ZERO (&readfs);
      FD_SET (0, &readfs);
      FD_SET (outp, &readfs);
      r = select (outp + 1, &readfs, 0, 0, 0);
      if (r < 0)
	{
	  if (errno != EINTR)
	    exit (fprintf (stderr, "select failed: %s\n", strerror (errno)));
	  continue;
	}
      if (FD_ISSET (0, &readfs))
	transfer (0, inp);
      if (FD_ISSET (outp, &readfs))
	transfer (outp, 1);
    }
  printf ("\n PROCESS ENDS\n");
  proc_end (ch, NULL);
}

static void
run_prog (char **argv, char *inp)
{
  char *out;
  int l;
  int i;
  int r =
    proc_run (argv[0], argv, NULL, inp, inp ? strlen (inp) : 0, &out, &l, 0,
	      0);
  if (r)
    exit (fprintf (stderr, "can not execute: %d (%s)\n", r, strerror (r)));
  for (i = 0; i < l; i++)
    out[i] = toupper (out[i]);
  fwrite (out, 1, l, stdout);
  printf ("\n");
}

int
main (int argc, char **argv)
{
  char *input = 0;
  if (argc > 1)
    {
      if (!strcmp (argv[1], "-y"))
	{
	  int i;
	  input = argv[2];
	  for (i = 3; i < argc; i++)
	    {
	      argv[i - 2] = argv[i];
	    }
	  argc -= 2;
	  argv[argc] = 0;
	}
      if (!strcmp (argv[1], "-s"))
	{
	  subprog ();
	  return 0;
	}
      if (!strcmp (argv[1], "-x"))
	{
	  run_prog (argv + 2, input);
	  return 0;
	}
    }
  test (argv);
  return 0;
}

#endif

static void
blt_prgout ()
{
  char *out;
  size_t out_l;
  int dummy;
  char *result;
  char **body;

  result = get_single_string (var_get ("_RESULT"));
  body =
    split_string_into_array (expand_variables_in_str (var_get ("_BODY")));

  if (proc_run (body[0], body, &dummy, 0, 0, &out, &out_l, 0, 0))
    exit (fprintf (stderr, "jj: error during execution "
		   "of %s. exiting\n", var_get ("_BODY")));

  result = mprintf ("$%s", result);
  var_set (result, out);
  free (result);
  free (out);
}

static void
blt_set ()
{
  char *name, *value;
  name = get_single_string (var_get ("_VARNAME"));
  if (!name)
    exit (fprintf (stderr, "jj: #set: empty variable name requested\n"));
  value = expand_variables_in_str (var_get ("_VALUE"));
  name = mprintf ("$%s", name);
  var_set (name, value);
  free (name);
}

static char **
strsplit (char *re, char *d)
{
  regex_t rx;
  int ec;
  if ((ec = regcomp (&rx, re, REG_EXTENDED)))
    {
      char ebuf[2000];
      regerror (ec, &rx, ebuf, sizeof (ebuf) - 1);
      exit (fprintf (stderr, "regcomp for '%s' failed: %s\n", re, ebuf));
    }
  char *orig_d = d;
  int nfields;
  char **fields = 0;

again:
  d = orig_d;
  nfields = 0;
  while (*d)
    {
      regmatch_t matches[2];
      if (regexec (&rx, d, 2, matches, 0))
	{
	  if (fields)
	    fields[nfields] = collect_substr (d, strlen (d));
	  nfields++;
	  d += strlen (d);
	}
      else
	{
	  if (matches[0].rm_so == 0)
	    {
	      d += matches[0].rm_eo;
	    }
	  else
	    {
	      if (fields)
		fields[nfields] = collect_substr (d, matches[0].rm_so);
	      d += matches[0].rm_eo;
	      nfields++;
	    }
	}
    }
  if (fields)
    {
      regfree (&rx);
      return fields;
    }
  if (!nfields)
    {
      regfree (&rx);
      return 0;
    }

  fields = (typeof (fields)) calloc ((nfields + 1), sizeof (fields[0]));

  fields[nfields] = 0;
  goto again;
}

static char *
collect_substr (char *str, int len)
{
  char *x;

  x = (typeof (x)) calloc ((len + 1), sizeof (x[0]));

  memcpy (x, str, len);
  x[len] = 0;
  return x;
}

static void
blt_local ()
{
  char *name;
  char **name_components;
  int i;
  name = var_get ("_VARNAMES");
  name_components = strsplit ("[[:space:]]+", name);
  if (!name_components || !name_components[0])
    exit (fprintf (stderr, "jj: #local: empty variable name requested\n"));
  for (i = 0; name_components[i]; i++)
    {
      name = mprintf ("$%s", name_components[i]);
      var_create (name, strdup (""));
      free (name);
    }
  free_string_array (name_components);
}

static void
blt_function ()
{
  char *name, **args, *body;
  func_t *F;
  int i;

  name = get_single_string (var_get ("_NAME"));
  if (!name)
    exit (fprintf (stderr, "jj: #function: empty name "
		   "given for function\n"));
  args = split_string_into_array (var_get ("_ARGS"));
  body = var_get ("_BODY");

  name = mprintf ("#%s", name);

  F = func_new (name);
  F->kind = fn_user;
  F->data = strdup (body);
  for (i = 0; args[i]; i++)
    {
      char *A;
      A = mprintf ("$%s", args[i]);
      strlist_append (&F->args, A);
    }
  free_string_array (args);
}

static char *
get_single_string (char *str)
{
  char **components;
  int i;
  char *R;
  components = strsplit ("[[:space:]]+", str);
  if (!components)
    return 0;
  if (!components[0])
    {
      free (components);
      return 0;
    }
  R = components[0];
  for (i = 1; components[i]; i++)
    free (components[i]);
  free (components);
  return R;
}

static char **
split_string_into_array (char *str)
{
  return strsplit ("[[:space:]]+", str);
}

static void
free_string_array (char **X)
{
  int i;
  if (!X)
    return;
  for (i = 0; X[i]; i++)
    free (X[i]);
  free (X);
}

static void
blt_strcat ()
{
  char *resultvar;
  char **str1_w, **str2_w;
  char *result;
  int L1, L2;
  int i, j;
  charbuffer_t *buffer;

  resultvar = get_single_string (var_get ("_RESULT"));

  if (!resultvar)
    exit (fprintf (stderr, "jj: #strcat: result variable must "
		   "not be null\n"));

  str1_w =
    split_string_into_array (expand_variables_in_str (var_get ("_STR1")));
  str2_w =
    split_string_into_array (expand_variables_in_str (var_get ("_STR2")));
  L1 = string_array_len (str1_w);
  L2 = string_array_len (str2_w);

  if (L1 == 0 || L2 == 0)
    {
      char *z;
      if (L1 == 0)
	z = "_STR2";
      else
	z = "_STR1";
      result = expand_variables_in_str (var_get (z));
      goto end;
    }

  buffer = charbuffer_new ();
  for (i = 0; i < L1; i++)
    for (j = 0; j < L2; j++)
      {
	if (i != 0 || j != 0)
	  charbuffer_append (buffer, ' ');
	charbuffer_putstr (buffer, str1_w[i]);
	charbuffer_putstr (buffer, str2_w[j]);
      }
  charbuffer_append (buffer, 0);

  result = charbuffer_collectda (buffer, &L1);
  free_string_array (str1_w);
  free_string_array (str2_w);
end:
  resultvar = mprintf ("$%s", resultvar);
  var_set (resultvar, result);
  free (resultvar);
}

static void
charbuffer_putstr (charbuffer_t * B, char *str)
{
  while (*str)
    {
      charbuffer_append (B, str[0]);
      str++;
    }
}

static int
string_array_len (char **x)
{
  int i;
  if (!x)
    return 0;
  for (i = 0; x[i]; i++)
    ;
  return i;
}

static void
blt_foreach ()
{
  char *name;
  char **value;
  char *body;
  int i;
  name = get_single_string (var_get ("_VARNAME"));
  if (!name)
    exit (fprintf (stderr, "jj: #foreach: empty variable name requested\n"));
  name = mprintf ("$%s", name);
  value =
    split_string_into_array (expand_variables_in_str (var_get ("_LIST")));
  body = var_get ("_BODY");
  frame_enter ();
  var_create (name, "");
  for (i = 0; value[i]; i++)
    {
      var_set (name, value[i]);
      ipret_block ("<internal>", body);
    }
  free (name);
  frame_leave ();
  free_string_array (value);
}

static void
blt_include ()
{
  char **fn;
  char *here;
  int i;
  here = strdup (var_get ("$HERE"));
  fn =
    split_string_into_array (expand_variables_in_str (var_get ("_FILENAME")));
  for (i = 0; fn[i]; i++)
    ipret_file (here, fn[i]);
  free_string_array (fn);
}

static void
blt_replace_suffix ()
{
  char *resultvar;
  char **source;
  char *newsfx;
  charbuffer_t *buffer;
  int i;

  resultvar = get_single_string (var_get ("_RESULT"));
  source =
    split_string_into_array (expand_variables_in_str (var_get ("_SOURCE")));
  newsfx = get_single_string (var_get ("_NEWSFX"));

  buffer = charbuffer_new ();
  for (i = 0; source[i]; i++)
    {
      if (i)
	charbuffer_append (buffer, ' ');
      charbuffer_putmem (buffer, source[i],
			 find_suffix_begin (source[i]) - source[i]);
      charbuffer_putstr (buffer, newsfx);
    }
  charbuffer_append (buffer, 0);
  resultvar = mprintf ("$%s", resultvar);
  var_set (resultvar, charbuffer_collectda (buffer, &i));
  free_string_array (source);
  free (resultvar);
}

static char *
find_suffix_begin (char *str)
{
  char *ret;
  ret = 0;
  while (*str)
    {
      if (*str == '.')
	ret = str;
      str++;
    }
  if (ret)
    return ret;
  return str;
}

static void charbuffer_putmem (charbuffer_t * buffer, char *mem, int len)
{
  int i;
  for (i = 0; i < len; i++)
    charbuffer_append (buffer, mem[i]);
}

static void
blt_nth ()
{
  int L;
  char *resultvar, *index, **source;
  int W;

  resultvar = get_single_string (var_get ("_RESULT"));
  source =
    split_string_into_array (expand_variables_in_str (var_get ("_SOURCE")));
  index = get_single_string (expand_variables_in_str (var_get ("_INDEX")));
  for (L = 0; source[L]; L++)
    ;
  W = atoi (index);
  resultvar = mprintf ("$%s", resultvar);
  if (W < 0 || W >= L)
    var_set (resultvar, "");
  else
    var_set (resultvar, source[W]);
  free (resultvar);
  free_string_array (source);
}

void symtab_init (symtab_t * t)
{
  t->root = 0;
}

symbol_t *symtab_destroy (symtab_t * t)
{

  struct symtab_t_NODE *N;
  symbol_t *retval;

  if (!t->root)
    /* FIXME: this should be configurable, ie. 
       the return value for unknowns should be
       variable depending on the type. for instance,
       maybe we want to return -1 for a tree of  integers.
       as it is, the tree is usable for pointers only */
    return 0;

  N = symtab_t_destroy_one_node (t->root, &t->root);
  retval = N->data;
  free (N);
  return retval;
}

symbol_t *symtab_find (symtab_t * t, symbol_t * key)
{
  struct symtab_t_NODE *n = t->root;
  while (n)
    {
      int u;
      u = symtab_t_compare (key, n->data);
      if (u == 0)
	return n->data;
      else if (u < 0)
	n = n->left;
      else
	n = n->right;
    }
  /* see FIXME above */
  return 0;
}

int symtab_insert (symtab_t * t, symbol_t * data)
{
  if (symtab_t_find_node (t->root, data))
    {
      return 1;
    }
  else
    {
      struct symtab_t_NODE *node;
      node = (struct symtab_t_NODE *) malloc (sizeof (*node));
      node->height = 1;
      node->left = node->right = 0;
      node->data = data;
      t->root = symtab_t_insert_node (t->root, node);
      return 0;
    }
}

symbol_t *symtab_remove (symtab_t * t, symbol_t * key)
{
  struct symtab_t_NODE *node;
  symbol_t *retval;
  retval = 0;
  node = symtab_t_find_node (t->root, key);
  if (node)
    {
      t->root = symtab_t_remove_node (t->root, node);
      retval = node->data;
      free (node);
    }
  return retval;
}

static struct symtab_t_NODE *symtab_t_insert_node
  (struct symtab_t_NODE *t, struct symtab_t_NODE *n)
{
  int u;
  if (!t)
    return n;
  u = symtab_t_compare (n->data, t->data);
  if (u < 0)
    t->left = symtab_t_insert_node (t->left, n);
  else
    t->right = symtab_t_insert_node (t->right, n);
  return symtab_t_balance (t);
}

static int inline
symtab_t_height (struct symtab_t_NODE *x)
{
  return x ? x->height : 0;
}

static struct symtab_t_NODE *
symtab_t_balance (struct symtab_t_NODE *t)
{
  int u;
  symtab_t_calc_height (t);
  u = symtab_t_height (t->left) - symtab_t_height (t->right);
  if (u > 1)
    return symtab_t_rotate_right (t);
  else if (u < -1)
    return symtab_t_rotate_left (t);
  else
    return t;
}

static struct symtab_t_NODE *symtab_t_remove_node
  (struct symtab_t_NODE *t, struct symtab_t_NODE *node)
{
  int u;
  u = symtab_t_compare (node->data, t->data);
  if (u < 0)
    t->left = symtab_t_remove_node (t->left, node);
  else if (u > 0)
    t->right = symtab_t_remove_node (t->right, node);
  else
    {
      if (!t->right || !t->left)
	{
	  if (t->right)
	    return t->right;
	  else
	    return t->left;
	}
      else
	{
	  struct symtab_t_NODE *p;
	  if (t->left->height > t->right->height)
	    p = symtab_t_remove_max (t->left, &t->left);
	  else
	    p = symtab_t_remove_min (t->right, &t->right);
	  p->left = t->left;
	  p->right = t->right;
	  p->height = 1;
	  t = p;
	}
    }
  return symtab_t_balance (t);
}

static struct symtab_t_NODE *
symtab_t_rotate_right (struct symtab_t_NODE *g)
{
  struct symtab_t_NODE *f, *e;
  f = g->left;
  e = f->right;
  f->right = g;
  g->left = e;
  symtab_t_calc_height (g);
  symtab_t_calc_height (f);
  return f;
}

static struct symtab_t_NODE *
symtab_t_rotate_left (struct symtab_t_NODE *g)
{
  struct symtab_t_NODE *f, *e;
  f = g->right;
  e = f->left;
  f->left = g;
  g->right = e;
  symtab_t_calc_height (g);
  symtab_t_calc_height (f);
  return f;
}

static struct symtab_t_NODE *symtab_t_remove_max
  (struct symtab_t_NODE *t, struct symtab_t_NODE **pl)
{
  if (t->right)
    {
      struct symtab_t_NODE *z;
      z = symtab_t_remove_max (t->right, &t->right);
      symtab_t_calc_height (t);
      return z;
    }
  *pl = t->left;
  return t;
}

static struct symtab_t_NODE *symtab_t_remove_min
  (struct symtab_t_NODE *t, struct symtab_t_NODE **pl)
{
  if (t->left)
    {
      struct symtab_t_NODE *z;
      z = symtab_t_remove_min (t->left, &t->left);
      symtab_t_calc_height (t);
      return z;
    }
  *pl = t->right;
  return t;
}

static void
symtab_t_calc_height (struct symtab_t_NODE *t)
{
  int a, b;
  a = symtab_t_height (t->left) + 1;
  b = symtab_t_height (t->right) + 1;
  if (a > b)
    t->height = a;
  else
    t->height = b;
}

static struct symtab_t_NODE *symtab_t_destroy_one_node
  (struct symtab_t_NODE *node, struct symtab_t_NODE **plink)
{
  if (node->left)
    return symtab_t_destroy_one_node (node->left, &node->left);
  else if (node->right)
    return symtab_t_destroy_one_node (node->right, &node->right);
  *plink = 0;
  return node;
}

static int
symtab_t_compare (symbol_t * X1, symbol_t * X2)
{

  return strcmp (X1->name, X2->name);

}

static struct symtab_t_NODE *
symtab_t_find_node (struct symtab_t_NODE *node, symbol_t * key)
{
  int cmp;
  if (!node)
    return 0;
  cmp = symtab_t_compare (key, node->data);
  if (cmp < 0)
    return symtab_t_find_node (node->left, key);
  else if (cmp > 0)
    return symtab_t_find_node (node->right, key);
  else
    return node;
}

context_t *context_new ()
{
  context_t *L;
  L = malloc (sizeof (*L));
  L->nelts = 0;
  L->size = 0;
  L->elts = 0;
  return L;
}

void context_init (context_t * L)
{
  L->nelts = 0;
  L->size = 0;
  L->elts = 0;
}

symtab_t *context_pop (context_t * L)
{
  symtab_t *R;
  L->nelts--;
  R = L->elts[L->nelts];
  return R;
}

void context_push (context_t * L, symtab_t * d)
{
  if (L->nelts == L->size)
    {
      if (!L->size)
	{
	  L->size = 20;
	  L->elts = calloc (L->size, sizeof (symtab_t *));
	}
      else
	{
	  L->size += L->size / 2;
	  L->elts = realloc (L->elts, L->size * sizeof (symtab_t *));
	}
    }
  L->elts[L->nelts] = d;
  L->nelts++;
}

context_t *context_destroy (context_t * L)
{
  if (L->size)
    free (L->elts);
  L->size = 0;
  return L;
}

int context_isempty (context_t * L)
{
  return L->nelts == 0;
}

char *
var_get (char *name)
{
  symbol_t *R;
  R = find_var (name);
  if (R)
    return R->value;
  return 0;
}

static symbol_t *
find_var (char *name)
{
  symbol_t fake;
  int i;
  fake.name = name;
  for (i = context->nelts - 1; i >= 0; i--)
    {
      symbol_t *R;
      R = symtab_find (context->elts[i], &fake);
      if (R)
	return R;
    }
  return 0;
}

void
var_set (char *name, char *val)
{
  symbol_t *R;
  R = find_var (name);
  if (R)
    {
      free (R->value);
      R->value = strdup (val);
    }
  else
    {

      R = (typeof (R)) calloc (1, sizeof (R[0]));

      R->name = strdup (name);
      R->value = strdup (val);
      symtab_insert (context->elts[0], R);
    }
}

void
var_create (char *name, char *val)
{
  symbol_t fake;
  fake.name = name;
  if (symtab_find (context->elts[context->nelts - 1], &fake))
    {
      var_set (name, val);
    }
  else
    {
      symbol_t *R;

      R = (typeof (R)) calloc (1, sizeof (R[0]));

      R->name = strdup (name);
      R->value = strdup (val);
      symtab_insert (context->elts[context->nelts - 1], R);
    }
}

void
frame_enter ()
{
  symtab_t *symtab;

  symtab = (typeof (symtab)) calloc (1, sizeof (symtab[0]));

  symtab_init (symtab);
  context_push (context, symtab);
}

void
frame_leave ()
{
  symtab_t *symtab;
  symbol_t *S;
  symtab = context_pop (context);
  while ((S = symtab_destroy (symtab)))
    {
      free (S->name);
      free (S->value);
      free (S);
    }
  free (symtab);
}

static void
var_init ()
{
  context = context_new ();
  frame_enter ();
}

void strlist_init (strlist_t * L)
{
  L->head.prev = L->head.next = &L->head;
}

char *strlist_destroy (strlist_t * L)
{
  typeof (L->head.next) N;
  char *R;

  N = L->head.next;
  if (N == &L->head)
    return 0;
  R = N->data;

  strlist_remove (L, N);
  return R;
}

strlist_t *strlist_new ()
{
  strlist_t *L;
  L = (typeof (L)) malloc (sizeof (*L));
  L->head.prev = L->head.next = &L->head;
  return L;
}

void strlist_append (strlist_t * L, char *data)
{
  struct strlist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->prev = L->head.prev;
  n->next = &L->head;
  L->head.prev->next = n;
  L->head.prev = n;
}

void strlist_prepend (strlist_t * L, char *data)
{
  struct strlist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->next = L->head.next;
  n->prev = &L->head;
  L->head.next->prev = n;
  L->head.next = n;
}

void strlist_remove (strlist_t * L, struct strlist_t_NODE *n)
{
  n->prev->next = n->next;
  n->next->prev = n->prev;
  free (n);
}

int strlist_isempty (strlist_t * L)
{
  return L->head.next == &L->head;
}

static void functab_init (functab_t * t)
{
  t->root = 0;
}

static func_t *functab_destroy (functab_t * t)
{

  struct functab_t_NODE *N;
  func_t *retval;

  if (!t->root)
    /* FIXME: this should be configurable, ie. 
       the return value for unknowns should be
       variable depending on the type. for instance,
       maybe we want to return -1 for a tree of  integers.
       as it is, the tree is usable for pointers only */
    return 0;

  N = functab_t_destroy_one_node (t->root, &t->root);
  retval = N->data;
  free (N);
  return retval;
}

static func_t *functab_find (functab_t * t, func_t * key)
{
  struct functab_t_NODE *n = t->root;
  while (n)
    {
      int u;
      u = functab_t_compare (key, n->data);
      if (u == 0)
	return n->data;
      else if (u < 0)
	n = n->left;
      else
	n = n->right;
    }
  /* see FIXME above */
  return 0;
}

static int functab_insert (functab_t * t, func_t * data)
{
  if (functab_t_find_node (t->root, data))
    {
      return 1;
    }
  else
    {
      struct functab_t_NODE *node;
      node = (struct functab_t_NODE *) malloc (sizeof (*node));
      node->height = 1;
      node->left = node->right = 0;
      node->data = data;
      t->root = functab_t_insert_node (t->root, node);
      return 0;
    }
}

static func_t *functab_remove (functab_t * t, func_t * key)
{
  struct functab_t_NODE *node;
  func_t *retval;
  retval = 0;
  node = functab_t_find_node (t->root, key);
  if (node)
    {
      t->root = functab_t_remove_node (t->root, node);
      retval = node->data;
      free (node);
    }
  return retval;
}

static struct functab_t_NODE *functab_t_insert_node
  (struct functab_t_NODE *t, struct functab_t_NODE *n)
{
  int u;
  if (!t)
    return n;
  u = functab_t_compare (n->data, t->data);
  if (u < 0)
    t->left = functab_t_insert_node (t->left, n);
  else
    t->right = functab_t_insert_node (t->right, n);
  return functab_t_balance (t);
}

static int inline
functab_t_height (struct functab_t_NODE *x)
{
  return x ? x->height : 0;
}

static struct functab_t_NODE *
functab_t_balance (struct functab_t_NODE *t)
{
  int u;
  functab_t_calc_height (t);
  u = functab_t_height (t->left) - functab_t_height (t->right);
  if (u > 1)
    return functab_t_rotate_right (t);
  else if (u < -1)
    return functab_t_rotate_left (t);
  else
    return t;
}

static struct functab_t_NODE *functab_t_remove_node
  (struct functab_t_NODE *t, struct functab_t_NODE *node)
{
  int u;
  u = functab_t_compare (node->data, t->data);
  if (u < 0)
    t->left = functab_t_remove_node (t->left, node);
  else if (u > 0)
    t->right = functab_t_remove_node (t->right, node);
  else
    {
      if (!t->right || !t->left)
	{
	  if (t->right)
	    return t->right;
	  else
	    return t->left;
	}
      else
	{
	  struct functab_t_NODE *p;
	  if (t->left->height > t->right->height)
	    p = functab_t_remove_max (t->left, &t->left);
	  else
	    p = functab_t_remove_min (t->right, &t->right);
	  p->left = t->left;
	  p->right = t->right;
	  p->height = 1;
	  t = p;
	}
    }
  return functab_t_balance (t);
}

static struct functab_t_NODE *
functab_t_rotate_right (struct functab_t_NODE *g)
{
  struct functab_t_NODE *f, *e;
  f = g->left;
  e = f->right;
  f->right = g;
  g->left = e;
  functab_t_calc_height (g);
  functab_t_calc_height (f);
  return f;
}

static struct functab_t_NODE *
functab_t_rotate_left (struct functab_t_NODE *g)
{
  struct functab_t_NODE *f, *e;
  f = g->right;
  e = f->left;
  f->left = g;
  g->right = e;
  functab_t_calc_height (g);
  functab_t_calc_height (f);
  return f;
}

static struct functab_t_NODE *functab_t_remove_max
  (struct functab_t_NODE *t, struct functab_t_NODE **pl)
{
  if (t->right)
    {
      struct functab_t_NODE *z;
      z = functab_t_remove_max (t->right, &t->right);
      functab_t_calc_height (t);
      return z;
    }
  *pl = t->left;
  return t;
}

static struct functab_t_NODE *functab_t_remove_min
  (struct functab_t_NODE *t, struct functab_t_NODE **pl)
{
  if (t->left)
    {
      struct functab_t_NODE *z;
      z = functab_t_remove_min (t->left, &t->left);
      functab_t_calc_height (t);
      return z;
    }
  *pl = t->right;
  return t;
}

static void
functab_t_calc_height (struct functab_t_NODE *t)
{
  int a, b;
  a = functab_t_height (t->left) + 1;
  b = functab_t_height (t->right) + 1;
  if (a > b)
    t->height = a;
  else
    t->height = b;
}

static struct functab_t_NODE *functab_t_destroy_one_node
  (struct functab_t_NODE *node, struct functab_t_NODE **plink)
{
  if (node->left)
    return functab_t_destroy_one_node (node->left, &node->left);
  else if (node->right)
    return functab_t_destroy_one_node (node->right, &node->right);
  *plink = 0;
  return node;
}

static int
functab_t_compare (func_t * X1, func_t * X2)
{

  return strcmp (X1->name, X2->name);

}

static struct functab_t_NODE *
functab_t_find_node (struct functab_t_NODE *node, func_t * key)
{
  int cmp;
  if (!node)
    return 0;
  cmp = functab_t_compare (key, node->data);
  if (cmp < 0)
    return functab_t_find_node (node->left, key);
  else if (cmp > 0)
    return functab_t_find_node (node->right, key);
  else
    return node;
}

func_t *
func_new (char *name)
{
  func_t *F;
  F = func_get (name);
  if (F)
    {
      char *X;
      while ((X = strlist_destroy (&F->args)))
	{
	  free (X);
	}
      if (F->kind == fn_user && F->data)
	free (F->data);
    }
  else
    {

      F = (typeof (F)) calloc (1, sizeof (F[0]));

      strlist_init (&F->args);
      F->name = strdup (name);
      functab_insert (funcs, F);
    }
  F->kind = fn_user;
  F->data = 0;
  return F;
}

func_t *
func_get (char *name)
{
  func_t fake;
  fake.name = name;
  func_t *R;
  R = functab_find (funcs, &fake);
  if (R)
    return R;
  return 0;
}

void
func_remove (char *name)
{
  func_t *F;
  F = func_get (name);
  if (F)
    {
      char *X;
      functab_remove (funcs, F);
      free (F->name);
      if (F->kind == fn_user && F->data)
	free (F->data);
      while ((X = strlist_destroy (&F->args)))
	free (X);
      free (F);
    }
}

void
func_init ()
{

  funcs = (typeof (funcs)) calloc (1, sizeof (funcs[0]));

  functab_init (funcs);
}

void symbollist_init (symbollist_t * L)
{
  L->head.prev = L->head.next = &L->head;
}

symbol_t *symbollist_destroy (symbollist_t * L)
{
  typeof (L->head.next) N;
  symbol_t *R;

  N = L->head.next;
  if (N == &L->head)
    return 0;
  R = N->data;

  symbollist_remove (L, N);
  return R;
}

symbollist_t *symbollist_new ()
{
  symbollist_t *L;
  L = (typeof (L)) malloc (sizeof (*L));
  L->head.prev = L->head.next = &L->head;
  return L;
}

void symbollist_append (symbollist_t * L, symbol_t * data)
{
  struct symbollist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->prev = L->head.prev;
  n->next = &L->head;
  L->head.prev->next = n;
  L->head.prev = n;
}

void symbollist_prepend (symbollist_t * L, symbol_t * data)
{
  struct symbollist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->next = L->head.next;
  n->prev = &L->head;
  L->head.next->prev = n;
  L->head.next = n;
}

void symbollist_remove (symbollist_t * L, struct symbollist_t_NODE *n)
{
  n->prev->next = n->next;
  n->next->prev = n->prev;
  free (n);
}

int symbollist_isempty (symbollist_t * L)
{
  return L->head.next == &L->head;
}

static void
blt_command ()
{
  strlist_t *body;
  char *S;
  char **target;
  command_t *C;

  body = parse_strlist (var_get ("_BODY"));

  C = (typeof (C)) calloc (1, sizeof (C[0]));

  C->fields = symbollist_new ();

  target = 0;
  {
    typeof ((*body).head.next) N898, T898;
    for (T898 = (*body).head.next; T898 != &((*body).head); T898 = N898)
      {
	typeof (T898->data) S;
	S = T898->data;
	N898 = T898->next;

	if (target)
	  {
	    *target = expand_variables_in_str (S);
	    target = 0;
	  }
	else
	  {
	    symbol_t *Y;

	    Y = (typeof (Y)) calloc (1, sizeof (Y[0]));

	    Y->name = S;
	    target = &Y->value;
	    symbollist_append (C->fields, Y);
	  }

      }
  }

  while ((S = strlist_destroy (body)))
    /* do not free, we stored them */ ;

  commandlist_append (commands, C);
}

void commandlist_init (commandlist_t * L)
{
  L->head.prev = L->head.next = &L->head;
}

command_t *commandlist_destroy (commandlist_t * L)
{
  typeof (L->head.next) N;
  command_t *R;

  N = L->head.next;
  if (N == &L->head)
    return 0;
  R = N->data;

  commandlist_remove (L, N);
  return R;
}

commandlist_t *commandlist_new ()
{
  commandlist_t *L;
  L = (typeof (L)) malloc (sizeof (*L));
  L->head.prev = L->head.next = &L->head;
  return L;
}

void commandlist_append (commandlist_t * L, command_t * data)
{
  struct commandlist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->prev = L->head.prev;
  n->next = &L->head;
  L->head.prev->next = n;
  L->head.prev = n;
}

void commandlist_prepend (commandlist_t * L, command_t * data)
{
  struct commandlist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->next = L->head.next;
  n->prev = &L->head;
  L->head.next->prev = n;
  L->head.next = n;
}

void commandlist_remove (commandlist_t * L, struct commandlist_t_NODE *n)
{
  n->prev->next = n->next;
  n->next->prev = n->prev;
  free (n);
}

int commandlist_isempty (commandlist_t * L)
{
  return L->head.next == &L->head;
}

commandlist_t *commands;

static strlist_t *
parse_strlist (char *input)
{
  strlist_t *R;
  int state = 0;
  int Z;
  char *t_begin;

  R = strlist_new ();
  state = 0;

  while (1)
    {
      {
	typeof (state) _X904 = state;
	typeof (*input) _Y904 = *input;
	enum
	{
	  _sw_case_904_default,

	  _sw_case_904_905,

	  _sw_case_904_906,

	  _sw_case_904_907,

	  _sw_case_904_908,

	  _sw_case_904_910,

	  _sw_case_904_911,

	  _sw_case_904_913,

	  _sw_case_904_915,

	  _sw_case_904_916,

	  _sw_case_904_917,

	  _sw_case_904_918,

	  _sw_case_904_919,

	  _sw_case_904_920,

	  _sw_case_904_921,

	  _sw_case_904_922,

	  _sw_case_904_923,

	  _sw_case_904_924,

	} _sw_var_904 = _sw_case_904_default;

	if (0)
	  {

	  }
	else if (_X904 == (0) && _Y904 == (0))
	  {

	    _sw_var_904 = _sw_case_904_905;

	  }
	else if (_X904 == (0) && _Y904 == (127))
	  {

	    _sw_var_904 = _sw_case_904_906;

	  }
	else if (_X904 == (0) && _Y904 >= (1) && _Y904 <= (32))
	  {

	    _sw_var_904 = _sw_case_904_907;

	  }
	else if (_X904 == (0) && _Y904 == (LCURLY))
	  {

	    _sw_var_904 = _sw_case_904_908;

	  }
	else if (_X904 == (0) && _Y904 == (RCURLY))
	  {

	    _sw_var_904 = _sw_case_904_910;

	  }
	else if (_X904 == (0) && _Y904 == ('$'))
	  {

	    _sw_var_904 = _sw_case_904_911;

	  }
	else if (_X904 == ('C') && _Y904 == (LCURLY))
	  {

	    _sw_var_904 = _sw_case_904_915;

	  }
	else if (_X904 == ('C') && _Y904 == (RCURLY))
	  {

	    _sw_var_904 = _sw_case_904_916;

	  }
	else if (_X904 == ('C') && _Y904 == (0))
	  {

	    _sw_var_904 = _sw_case_904_917;

	  }
	else if (_X904 == ('W') && _Y904 == (0))
	  {

	    _sw_var_904 = _sw_case_904_919;

	  }
	else if (_X904 == ('W') && _Y904 >= (1) && _Y904 <= (32))
	  {

	    _sw_var_904 = _sw_case_904_920;

	  }
	else if (_X904 == ('W') && _Y904 == (RCURLY))
	  {

	    _sw_var_904 = _sw_case_904_921;

	  }
	else if (_X904 == ('W') && _Y904 == (LCURLY))
	  {

	    _sw_var_904 = _sw_case_904_922;

	  }
	else if (_X904 == (0))
	  {

	    _sw_var_904 = _sw_case_904_913;

	  }
	else if (_X904 == ('C'))
	  {

	    _sw_var_904 = _sw_case_904_918;

	  }
	else if (_X904 == ('W'))
	  {

	    _sw_var_904 = _sw_case_904_923;

	  }
	else if (_Y904 == (0))
	  {

	    _sw_var_904 = _sw_case_904_924;

	  }
	switch (_sw_var_904)
	  {

	  case _sw_case_904_905:

	    goto end;

	  case _sw_case_904_906:

	  case _sw_case_904_907:

	    input++;
	    break;

	  case _sw_case_904_908:

	    Z = 1;
	    t_begin = input;
	    input++;
	    state = 'C';
	    break;

	  case _sw_case_904_910:

	    do_error ("<internal>", input, "unmatched curly brace");
	    break;

	  case _sw_case_904_911:

	    t_begin = input;
	    input++;
	    state = 'W';
	    break;

	  case _sw_case_904_913:

	    t_begin = input;
	    input++;
	    state = 'W';
	    break;

	  case _sw_case_904_915:

	    Z++;
	    input++;
	    break;

	  case _sw_case_904_916:

	    input++;
	    Z--;
	    if (Z != 0)
	      break;
	    t_begin++;
	    strlist_append (R, make_str (t_begin, input - t_begin - 1));
	    state = 0;
	    break;

	  case _sw_case_904_917:

	    do_error ("<internal>", 0, "unexpected EOF in string");
	    break;

	  case _sw_case_904_918:

	    input++;
	    break;

	  case _sw_case_904_919:

	  case _sw_case_904_920:

	  case _sw_case_904_921:

	  case _sw_case_904_922:

	    state = 0;
	    strlist_append (R, make_str (t_begin, input - t_begin));
	    break;

	  case _sw_case_904_923:

	    input++;
	    break;

	  case _sw_case_904_924:

	    do_error ("<internal>", 0, "unexptected EOF in string");

	  default:

	    break;
	  }
      }

    }

end:
  return R;
}

void
cmd_init ()
{
  commands = commandlist_new ();
}

void
prepare_commands ()
{
  {
    typeof ((*commands).head.next) N928, T928;
    for (T928 = (*commands).head.next;
	 T928 != &((*commands).head); T928 = N928)
      {
	typeof (T928->data) C;
	C = T928->data;
	N928 = T928->next;

	prepare_command (C);
	if (!C->action || !C->outputs)
	  {
	    fprintf (stderr, "jj: removing mysterious command"
		     "with no action or output files\n");
	    {
	      T928->prev->next = T928->next;
	      T928->next->prev = T928->prev;
	      free (T928);
	    }

	    /* FIXME: free C also */
	  }

      }
  }

}

static void
prepare_command (command_t * C)
{
  frame_enter ();
  {
    typeof ((*(C->fields)).head.next) N932, T932;
    for (T932 = (*(C->fields)).head.next;
	 T932 != &((*(C->fields)).head); T932 = N932)
      {
	typeof (T932->data) S;
	S = T932->data;
	N932 = T932->next;

	char *g;
	g = mprintf ("$%s", S->name);
	var_create (g, S->value);
	free (g);

  }}

  C->message = get_simple_field ("$message");
  C->action = get_simple_field ("$action");
  replace_newlines_with_spaces (C->action);
  C->outputs = get_array_field ("$outputs");
  C->triggers = get_array_field ("$triggers");
  frame_leave ();
}

static void
replace_newlines_with_spaces (char *X)
{
  int i;
  for (i = 0; X[i]; i++)
    if ((X[i] > 0 && X[i] < ' ') || X[i] == 127)
      X[i] = ' ';
}

static char *
get_simple_field (char *vname)
{
  return expand_variables_in_str (strdup (var_get (vname)));
}

static char **
get_array_field (char *vname)
{
  char *val;
  val = var_get (vname);
  if (!val)
    return 0;
  val = expand_variables_in_str (strdup (val));
  return split_string_into_array (val);
}

/* FIXME: consider what happens when you have
	-l$XX etc.. in this case, expand_var would
	really expand XX. do we want that? 
or consider:
	$XX/yy
	what happens then? */

void strtree_init (strtree_t * t)
{
  t->root = 0;
}

char *strtree_destroy (strtree_t * t)
{

  struct strtree_t_NODE *N;
  char *retval;

  if (!t->root)
    /* FIXME: this should be configurable, ie. 
       the return value for unknowns should be
       variable depending on the type. for instance,
       maybe we want to return -1 for a tree of  integers.
       as it is, the tree is usable for pointers only */
    return 0;

  N = strtree_t_destroy_one_node (t->root, &t->root);
  retval = N->data;
  free (N);
  return retval;
}

char *strtree_find (strtree_t * t, char *key)
{
  struct strtree_t_NODE *n = t->root;
  while (n)
    {
      int u;
      u = strtree_t_compare (key, n->data);
      if (u == 0)
	return n->data;
      else if (u < 0)
	n = n->left;
      else
	n = n->right;
    }
  /* see FIXME above */
  return 0;
}

int strtree_insert (strtree_t * t, char *data)
{
  if (strtree_t_find_node (t->root, data))
    {
      return 1;
    }
  else
    {
      struct strtree_t_NODE *node;
      node = (struct strtree_t_NODE *) malloc (sizeof (*node));
      node->height = 1;
      node->left = node->right = 0;
      node->data = data;
      t->root = strtree_t_insert_node (t->root, node);
      return 0;
    }
}

char *strtree_remove (strtree_t * t, char *key)
{
  struct strtree_t_NODE *node;
  char *retval;
  retval = 0;
  node = strtree_t_find_node (t->root, key);
  if (node)
    {
      t->root = strtree_t_remove_node (t->root, node);
      retval = node->data;
      free (node);
    }
  return retval;
}

static struct strtree_t_NODE *strtree_t_insert_node
  (struct strtree_t_NODE *t, struct strtree_t_NODE *n)
{
  int u;
  if (!t)
    return n;
  u = strtree_t_compare (n->data, t->data);
  if (u < 0)
    t->left = strtree_t_insert_node (t->left, n);
  else
    t->right = strtree_t_insert_node (t->right, n);
  return strtree_t_balance (t);
}

static int inline
strtree_t_height (struct strtree_t_NODE *x)
{
  return x ? x->height : 0;
}

static struct strtree_t_NODE *
strtree_t_balance (struct strtree_t_NODE *t)
{
  int u;
  strtree_t_calc_height (t);
  u = strtree_t_height (t->left) - strtree_t_height (t->right);
  if (u > 1)
    return strtree_t_rotate_right (t);
  else if (u < -1)
    return strtree_t_rotate_left (t);
  else
    return t;
}

static struct strtree_t_NODE *strtree_t_remove_node
  (struct strtree_t_NODE *t, struct strtree_t_NODE *node)
{
  int u;
  u = strtree_t_compare (node->data, t->data);
  if (u < 0)
    t->left = strtree_t_remove_node (t->left, node);
  else if (u > 0)
    t->right = strtree_t_remove_node (t->right, node);
  else
    {
      if (!t->right || !t->left)
	{
	  if (t->right)
	    return t->right;
	  else
	    return t->left;
	}
      else
	{
	  struct strtree_t_NODE *p;
	  if (t->left->height > t->right->height)
	    p = strtree_t_remove_max (t->left, &t->left);
	  else
	    p = strtree_t_remove_min (t->right, &t->right);
	  p->left = t->left;
	  p->right = t->right;
	  p->height = 1;
	  t = p;
	}
    }
  return strtree_t_balance (t);
}

static struct strtree_t_NODE *
strtree_t_rotate_right (struct strtree_t_NODE *g)
{
  struct strtree_t_NODE *f, *e;
  f = g->left;
  e = f->right;
  f->right = g;
  g->left = e;
  strtree_t_calc_height (g);
  strtree_t_calc_height (f);
  return f;
}

static struct strtree_t_NODE *
strtree_t_rotate_left (struct strtree_t_NODE *g)
{
  struct strtree_t_NODE *f, *e;
  f = g->right;
  e = f->left;
  f->left = g;
  g->right = e;
  strtree_t_calc_height (g);
  strtree_t_calc_height (f);
  return f;
}

static struct strtree_t_NODE *strtree_t_remove_max
  (struct strtree_t_NODE *t, struct strtree_t_NODE **pl)
{
  if (t->right)
    {
      struct strtree_t_NODE *z;
      z = strtree_t_remove_max (t->right, &t->right);
      strtree_t_calc_height (t);
      return z;
    }
  *pl = t->left;
  return t;
}

static struct strtree_t_NODE *strtree_t_remove_min
  (struct strtree_t_NODE *t, struct strtree_t_NODE **pl)
{
  if (t->left)
    {
      struct strtree_t_NODE *z;
      z = strtree_t_remove_min (t->left, &t->left);
      strtree_t_calc_height (t);
      return z;
    }
  *pl = t->right;
  return t;
}

static void
strtree_t_calc_height (struct strtree_t_NODE *t)
{
  int a, b;
  a = strtree_t_height (t->left) + 1;
  b = strtree_t_height (t->right) + 1;
  if (a > b)
    t->height = a;
  else
    t->height = b;
}

static struct strtree_t_NODE *strtree_t_destroy_one_node
  (struct strtree_t_NODE *node, struct strtree_t_NODE **plink)
{
  if (node->left)
    return strtree_t_destroy_one_node (node->left, &node->left);
  else if (node->right)
    return strtree_t_destroy_one_node (node->right, &node->right);
  *plink = 0;
  return node;
}

static int
strtree_t_compare (char *X1, char *X2)
{

  return strcmp (X1, X2);

}

static struct strtree_t_NODE *
strtree_t_find_node (struct strtree_t_NODE *node, char *key)
{
  int cmp;
  if (!node)
    return 0;
  cmp = strtree_t_compare (key, node->data);
  if (cmp < 0)
    return strtree_t_find_node (node->left, key);
  else if (cmp > 0)
    return strtree_t_find_node (node->right, key);
  else
    return node;
}

void
run_commands ()
{
  int change;
  strtree_t *input_set;

  input_set = (typeof (input_set)) calloc (1, sizeof (input_set[0]));

  strtree_init (input_set);

  {
    typeof ((*commands).head.next) N943, T943;
    for (T943 = (*commands).head.next;
	 T943 != &((*commands).head); T943 = N943)
      {
	typeof (T943->data) C;
	C = T943->data;
	N943 = T943->next;

	int i;
	for (i = 0; C->triggers[i]; i++)
	  strtree_insert (input_set, C->triggers[i]);

      }
  }

  {
    typeof ((*commands).head.next) N945, T945;
    for (T945 = (*commands).head.next;
	 T945 != &((*commands).head); T945 = N945)
      {
	typeof (T945->data) C;
	C = T945->data;
	N945 = T945->next;

	int i;
	for (i = 0; C->outputs[i]; i++)
	  strtree_remove (input_set, C->outputs[i]);

      }
  }

  change = 1;
  while (change && !commandlist_isempty (commands))
    {
      change = 0;
      {
	typeof ((*commands).head.next) N947, T947;
	for (T947 = (*commands).head.next;
	     T947 != &((*commands).head); T947 = N947)
	  {
	    typeof (T947->data) C;
	    C = T947->data;
	    N947 = T947->next;

	    if (execute_command (input_set, C))
	      {
		{
		  T947->prev->next = T947->next;
		  T947->next->prev = T947->prev;
		  free (T947);
		}

		change = 1;
	      }

	  }
      }

    }
}

static int execute_command (strtree_t * input_set, command_t * C)
{
  int i;
  time_t input_mtime;
  time_t output_mtime;

  for (i = 0; C->triggers[i]; i++)
    if (!strtree_find (input_set, C->triggers[i]))
      return 0;

  input_mtime = 0;
  for (i = 0; C->triggers[i]; i++)
    {
      time_t t;
      t = get_modtime (C->triggers[i]);
      if (t > input_mtime)
	input_mtime = t;
    }

  for (i = 0; C->outputs[i]; i++)
    {
      time_t t;
      t = get_modtime_weak (C->outputs[i]);
      if (i == 0 || t < output_mtime)
	output_mtime = t;
    }

  if (input_mtime < output_mtime)
    goto all_done;

  if (messages_only)
    {
      printf ("%s\n", C->message ? C->message : C->action);
    }
  else
    {
      printf ("%s\n", C->action);
    }

  if (system (C->action))
    exit (fprintf (stderr, "jj: build failed. exiting\n"));

  for (i = 0; C->outputs[i]; i++)
    get_modtime_force (C->outputs[i]);

all_done:
  for (i = 0; C->outputs[i]; i++)
    strtree_insert (input_set, C->outputs[i]);
  return 1;
}

static void
blt_modify ()
{
  char **targets;
  strlist_t *body;

  targets =
    split_string_into_array (expand_variables_in_str (var_get ("_TARGETS")));
  body = parse_strlist (var_get ("_BODY"));

  {
    typeof ((*commands).head.next) N955, T955;
    for (T955 = (*commands).head.next;
	 T955 != &((*commands).head); T955 = N955)
      {
	typeof (T955->data) C;
	C = T955->data;
	N955 = T955->next;

	if (command_has_target (C, targets))
	  modify_command (C, body);

      }
  }

}

static int command_has_target (command_t * C, char **targets)
{
  int i, j;
  int R;
  prepare_command (C);

  R = 0;
  for (i = 0; C->outputs[i]; i++)
    for (j = 0; targets[j]; j++)
      if (!strcmp (C->outputs[i], targets[j]))
	{
	  R = 1;
	  break;
	}

  free (C->message);
  free (C->action);
  free_string_array (C->outputs);
  free_string_array (C->triggers);

  return R;
}

static void modify_command (command_t * C, strlist_t * body)
{
  char *target;
  target = 0;
  {
    typeof ((*body).head.next) N959, T959;
    for (T959 = (*body).head.next; T959 != &((*body).head); T959 = N959)
      {
	typeof (T959->data) S;
	S = T959->data;
	N959 = T959->next;

	if (target)
	  {
	    modify_field (C->fields, target, S);
	    target = 0;
	  }
	else
	  {
	    target = S;
	  }

      }
  }

}

static void modify_field (symbollist_t * SL, char *field, char *value)
{
  int do_append = 0;
  symbol_t *L;
  if (field[0] == '+')
    {
      field++;
      do_append = 1;
    }
  value = expand_variables_in_str (value);
  {
    typeof ((*SL).head.next) N962, T962;
    for (T962 = (*SL).head.next; T962 != &((*SL).head); T962 = N962)
      {
	typeof (T962->data) S;
	S = T962->data;
	N962 = T962->next;

	if (!strcmp (S->name, field))
	  {
	    if (do_append && S->value && S->value[0])
	      {
		S->value = mprintf ("%s %s", S->value, value);
	      }
	    else
	      S->value = strdup (value);
	    return;
	  }

      }
  }

  L = (typeof (L)) calloc (1, sizeof (L[0]));

  L->name = strdup (field);
  L->value = strdup (value);
  symbollist_append (SL, L);
}
