
#if 0


#endif
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "parser.h"
#include "table.h"

#include "builtin.h"



arg_t *blt_print(arg_t *call,frame_t *F);

arg_t *string_cat(arg_t *call,frame_t *F);

arg_t *blt_dump(arg_t *call,frame_t *F);

arg_t *blt_set(arg_t *call,frame_t *F);

 static  strtab_t functions;






























 void
init_builtin_functions() {
	
{
        function_t *F;
        
	(F)= malloc(sizeof(*(F)));


        F->name= strdup("print");
        F->func= blt_print;
        F->kind= 'B';
        strtab_insert(&functions, F->name,F);
}


{
        function_t *F;
        
	(F)= malloc(sizeof(*(F)));


        F->name= strdup("str.cat");
        F->func= string_cat;
        F->kind= 'B';
        strtab_insert(&functions, F->name,F);
}


{
        function_t *F;
        
	(F)= malloc(sizeof(*(F)));


        F->name= strdup("dump");
        F->func= blt_dump;
        F->kind= 'B';
        strtab_insert(&functions, F->name,F);
}


{
        function_t *F;
        
	(F)= malloc(sizeof(*(F)));


        F->name= strdup("set");
        F->func= blt_set;
        F->kind= 'B';
        strtab_insert(&functions, F->name,F);
}


}











 arg_t *
exec_stmt(stmt_t *S, frame_t *frame) {
	function_t *F;

	F= strtab_find(&functions,S->func);
	if (!F)
		exit(fprintf(stderr,"can not find function %s\n",S->func));

	if (F->kind=='B')  {
		arg_t* (*func)(arg_t*,frame_t*);
		func= F->func;
		return (*func)(&S->args, frame);
	} else {
		exit(fprintf(stderr,"can not execute user defined function %s yet\n",S->func));
	}
	return 0;
}



 arg_t *frame_get(frame_t *F,char *name) {
	return (arg_t*) strtab_find(&F->locals,name);
}





 void frame_set(frame_t *F,char *name,arg_t *value) {
	arg_t *current;
	current= frame_get(F, name);
	if (current) {
		arg_destroy_deep(current);
		strtab_remove(&F->locals, name);
	}
	
	strtab_insert(&F->locals,name, arg_copy_deep(value));
}


arg_t* blt_set(arg_t *call, frame_t *frame) {
	arg_t *var;
	arg_t *expr;

	expr= arglist(call, 0);
	var= arglist(call,1);
	if (!expr || !var)
		exit(fprintf(stderr,"wrong number of arguments to function `set'\n"));

	stmt_t *statements;
	char *err= parse_arg( expr, &statements );
	if (err)
		exit(fprintf(stderr,"%s\n",err));

	arg_t *ret;
	arg_t *result=0;
	stmt_t *S;
	  {
	void *N18;
	for(S=statements->next;S!=statements;S=N18)  {
		N18= S->next;

		arg_t *ret;
		ret= exec_stmt(S,frame);
		if (ret) {
			if (result)
				arg_destroy_deep(result);
			result= ret;
		}
	
    } }



	if (result) {
		if (var->tokens.next->kind!='W')
			exit(fprintf(stderr,"wrong kind of argument to function `set'\n"));
		frame_set(frame, var->tokens.next->data, result);
	}

	return 0;
}


 arg_t *arglist(arg_t *L,int nr) {
	int i=0;
	arg_t *a;
	  {
	void *N21;
	for(a=L->next;a!=L;a=N21)  {
		N21= a->next;

		if (i==nr)
			return a;
		i++;
	
    } }


	return 0;
}

