
#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <stdarg.h>
#include <string.h>

#include "table.h"
#include "parser.h"
#include "functions.h"
#include "string.h"
#include "fileio.h"
#include "mprintf.h"

#include "gccdeps.h"

 static  void read_deps(char *fname) ; static  int shrink_pairs(char *buf,char *p,int rep) ; static  void replace_range(char *buf,int lower, int upper, int rep) ; static  void read_deps_from_dir(char *dname) ; static  int has_suffix(char *str,char *sfx) ;
 static  strtab_t gcc_deps;




/* usage: {dirname} depdir */
arg_t *blt_depdir(arg_t *call,frame_t *frame) {
	arg_t *darg;
	char *dname;
	darg= arglist(call,0);
	if (!darg)
		wrong_args("depdir");
	dname= arg_to_string(darg,frame);
	read_deps_from_dir(dname);
	free(dname);
	return 0;
}








  


 static  void read_deps(char *fname) {
	char *buf;
	char *target;
	char *part;
	char *sources,*targets;

	int pno;
	buf= file_read_all(fname);
	if (!buf)
		return ;
	shrink_pairs(buf,"\\\n",' ');
	replace_range(buf, 1, ' ', ' ');
	while(shrink_pairs(buf,"  ", ' '))
		;
	pno= 0;
	
{
	
	
	char *_src = buf;
	char _div= ':';
	char *_s, *_e;

	_s= _src;
	_e= _src;

_str_loop_13:
	while(*_e && *_e!=_div) 
		_e++;

	if (_e==_s) {
		part= 0;
	} else {
		int _L= _e-_s;
		part= (char*) malloc(_L+1);
		memcpy(part, _s, _L);
		part[_L]= 0;
	}
	{ /* brace for code, not necessary, but maybe
	the user has some declarations eh? */


		if (pno)
			sources= part;
		else
			targets= part;
		pno++;
		part= 0;
	
	}
_str_cont_13:
	if (part) free(part);
	if (!*_e) goto _str_exit_13;
	_e++;
	if (*_e) {
		_s= _e;
		goto _str_loop_13;
	}
_str_exit_13:
	_e= _s; /* to keep the compiler happy */
}


	free(buf);
/*	printf("sources= <%s>\n",sources);
	printf("targets= <%s>\n",targets);*/
	if (!sources || !targets)
		return ;

	
{
	
	
	char *_src = targets;
	char _div= ' ';
	char *_s, *_e;

	_s= _src;
	_e= _src;

_str_loop_15:
	while(*_e && *_e!=_div) 
		_e++;

	if (_e==_s) {
		target= 0;
	} else {
		int _L= _e-_s;
		target= (char*) malloc(_L+1);
		memcpy(target, _s, _L);
		target[_L]= 0;
	}
	{ /* brace for code, not necessary, but maybe
	the user has some declarations eh? */


		char *v;
		if (!target)
			
	goto _str_cont_15;

		v= strtab_find(&gcc_deps, target);
		if (v) {
			char *u= mprintf("%s %s",v,sources);
			strtab_remove(&gcc_deps, target);
			free(v);
			v= u;
		} else v= strdup(sources);
		strtab_insert(&gcc_deps, target, v);
	
	}
_str_cont_15:
	if (target) free(target);
	if (!*_e) goto _str_exit_15;
	_e++;
	if (*_e) {
		_s= _e;
		goto _str_loop_15;
	}
_str_exit_15:
	_e= _s; /* to keep the compiler happy */
}


	free(sources);
	free(targets);
}

 char *get_gcc_deps(char *target) {
	char *deps;
	deps=  strtab_find(&gcc_deps, target);
	return deps;
}




 static  int shrink_pairs(char *buf,char *p,int rep) {
	char *dst;
	int change= 0;
	dst= buf;

initial:
	if (buf[0]==0) {
		*dst= 0;
		return change;
	}

	if (buf[0]!=p[0]) {
		buf++;
		dst++;
		goto initial;
	}

	if (buf[1]!=p[1]) {
		buf++;
		dst++;
		goto initial;
	}

	dst[0]= rep;
	buf+= 2;
	dst++;
	change= 1;
	goto initial;
}

 static  void replace_range(char *buf,int lower, int upper, int rep) {
	int i;
	for(i=0;buf[i];i++)
		if (buf[i]>=lower && buf[i]<=upper)
			buf[i]= rep;
}

 static  void read_deps_from_dir(char *dname) {
	DIR *dir= opendir(dname);
	struct dirent *dirent;
	if (!dir)
		return ;
	while((dirent=readdir(dir))) {
		char buf[2000];
		if (has_suffix(dirent->d_name, ".d")) {
			sprintf(buf,"%s/%s",dname, dirent->d_name);
		 	read_deps(buf);
		}
	}
	closedir(dir);
}

 static  int has_suffix(char *str,char *sfx) {
	int La= strlen(str);
	int Lb= strlen(sfx);
	if (La<Lb)
		return 0;
	return !strcmp(str+La-Lb, sfx);
}


