
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include "parser.h"
#include "table.h"
#include "functions.h"
#include "extlibs.h"

#include "string.h"

 static  arg_t *flatten(arg_t *orig) ; static  token_t*
sfxrep(token_t *srct,char *orig,char *rep) ; static  int 
prep_string(arg_t *arg, frame_t *frame, char *result) ; static  int put_string(char *result, int len, char *src) ; static  int put_token(char *result, int len, int tk) ; static  void prepend_string_into_arg(char *pfx,char *sfx, arg_t *a,int lno) ;







/* $X $Y str.cat */
arg_t* string_cat(arg_t *call, frame_t *F) {
	arg_t *args= flatten(call);

	char *result= 0;
	int len;
	
	len= stringcat(args, 0, F);
	result= malloc(len);
	stringcat(args, result, F);

	arg_t *a;
	token_t *T;
	
	(T)= (typeof(T)) malloc(sizeof(*(T)));


	T->kind= 'W';
	/* FIXME: args can be empty, so no
		guarantee that this will be a logical value */
	T->lineno= args->tokens.next->lineno;
	T->data= result;

	
	(a)= (typeof(a)) malloc(sizeof(*(a)));


	a->tokens.prev= a->tokens.next= &a->tokens;
	 {
	(T)->prev= ((&a->tokens))->prev; 
	(T)->next= ((&a->tokens)); 
	((&a->tokens))->prev->next= (T); 
	((&a->tokens))->prev= (T); 
}



	arg_destroy_deep(args);
	return a;
}

 char *arg_to_string(arg_t *arg,frame_t *F) {
	char *result= 0;
	int len;
	
	len= stringcat(arg, 0, F);
	result= malloc(len);
	stringcat(arg, result, F);
	return result;
}

 int stringcat(arg_t *arg,char *out,frame_t *F) {
	token_t *T;
	int len= 0;
	  {
	void *N7;
	for(T=(&arg->tokens)->next;T!=(&arg->tokens);T=N7)  {
		N7= T->next;

		if (T->kind!='W')
			continue;
		if (T->data[0]=='$') {
			arg_t *a=0;
			token_t *subt;
			a= var_get(T->data, F);
			if (!a)
				exit(fprintf(stderr,"can not find variable %s\n",T->data));
			  {
	void *N8;
	for(subt=(&a->tokens)->next;subt!=(&a->tokens);subt=N8)  {
		N8= subt->next;

				switch(subt->kind) {
				case '{': if (out) out[len]= '{'; len++; break;
				case '}': if (out) out[len]= '}'; len++; break;
				case 'W': if (out)
						strcpy(out+len,subt->data);
					len+= strlen(subt->data);
					break;
				}
			
    } }


		} else {
			if (out)
				strcpy(out+len, T->data);
			len+= strlen(T->data);
		}
	
    } }


	if (out)
		out[len]= 0;
	return len+1;
}












 static  arg_t *flatten(arg_t *orig) {
	arg_t *R;
	
	(R)= (typeof(R)) malloc(sizeof(*(R)));


	R->tokens.prev= R->tokens.next= &R->tokens;
	arg_t *A;
	  {
	void *N20;
	for(A=orig->next;A!=orig;A=N20)  {
		N20= A->next;

		token_t *T;
		  {
	void *N21;
	for(T=(&A->tokens)->next;T!=(&A->tokens);T=N21)  {
		N21= T->next;

			token_t *C;
			C= token_copy_deep(T);
			 {
	(C)->prev= ((&R->tokens))->prev; 
	(C)->next= ((&R->tokens)); 
	((&R->tokens))->prev->next= (C); 
	((&R->tokens))->prev= (C); 
}


		
    } }


	
    } }


	return R;
}

arg_t *blt_strsfxrep(arg_t *call,frame_t *frame) {
	arg_t *input = arglist(call,0);
	arg_t *oldsfx_a= arglist(call,1);
	arg_t *newsfx_a= arglist(call,2);
	arg_t *output_a= arglist(call,3);

	if (!input || !oldsfx_a || !newsfx_a || !output_a)
		wrong_args("rep.sfx");

	token_t *output= toklist(&output_a->tokens,0);
	if (!output || output->kind!='W' || output->data[0]!='$')
		wrong_args("rep.sfx");

	token_t *oldsfx= toklist(&oldsfx_a->tokens,0);
	if (!oldsfx || oldsfx->kind!='W')
		wrong_args("rep.sfx");

	token_t *newsfx= toklist(&newsfx_a->tokens,0);
	if (!newsfx || newsfx->kind!='W')
		wrong_args("rep.sfx");

	arg_t *nV;
	
	(nV)= (typeof(nV)) malloc(sizeof(*(nV)));


	nV->tokens.prev= nV->tokens.next= &nV->tokens;

	token_t *oV;
	  {
	void *N26;
	for(oV=(&input->tokens)->next;oV!=(&input->tokens);oV=N26)  {
		N26= oV->next;

		if (oV->kind!='W')
			continue;
		if (oV->data[0]!='$') {
			token_t *T= sfxrep( oV, oldsfx->data, newsfx->data);
			 {
	(T)->prev= ((&nV->tokens))->prev; 
	(T)->next= ((&nV->tokens)); 
	((&nV->tokens))->prev->next= (T); 
	((&nV->tokens))->prev= (T); 
}


		} else {
			arg_t *A;
			A= var_get(oV->data, frame);
			if (!A) {
				token_t *T= token_copy_deep(oV);
				 {
	(T)->prev= ((&nV->tokens))->prev; 
	(T)->next= ((&nV->tokens)); 
	((&nV->tokens))->prev->next= (T); 
	((&nV->tokens))->prev= (T); 
}


			} else {
				token_t *S;
				  {
	void *N29;
	for(S=(&A->tokens)->next;S!=(&A->tokens);S=N29)  {
		N29= S->next;

					token_t *T= sfxrep(S, oldsfx->data,  newsfx->data);
					 {
	(T)->prev= ((&nV->tokens))->prev; 
	(T)->next= ((&nV->tokens)); 
	((&nV->tokens))->prev->next= (T); 
	((&nV->tokens))->prev= (T); 
}


				
    } }


			}
				
		}
	
    } }



	var_set(output->data, nV,frame);


	return 0;
}


 static  token_t*
sfxrep(token_t *srct,char *orig,char *rep) {
	char *V;
	char *src= srct->data;
	int oL= strlen(orig);
	int rL= strlen(rep);
	int sL= strlen(src);

	if (sL<oL || strcmp(src+sL-oL,orig))
		V= strdup(src);
	else {
		V= malloc(sL-oL+rL+1);
		memcpy(V, src, sL-oL);
		memcpy(V+sL-oL, rep, rL);
		V[sL-oL+rL]= 0;
	}
	
	token_t *T;
	
	(T)= (typeof(T)) malloc(sizeof(*(T)));


	T->kind= 'W';
	T->data= V;
	T->lineno= srct->lineno;
	return T;
}



 char *
arg_to_string_noforce(arg_t *arg,frame_t *F) {
	char *result;
	int len;
	len= prep_string(arg, F,0);
	if (len<2)
		return 0;
	result= malloc(len);
	prep_string(arg,F,result);
	result[strlen(result)-1]= 0;
	return result;
}

 static  int 
prep_string(arg_t *arg, frame_t *frame, char *result) {
	token_t *T;
	int len=0;
	  {
	void *N38;
	for(T=(&arg->tokens)->next;T!=(&arg->tokens);T=N38)  {
		N38= T->next;

		if (T->kind!='W')  {
			len= put_token(result,len,T->kind);
		} else if (T->data[0]!='$') {
			len= put_string( result, len, T->data );
		} else {
			arg_t *A;
			A= var_get(T->data, frame);
			if (A) {
				token_t *S;
				  {
	void *N39;
	for(S=(&A->tokens)->next;S!=(&A->tokens);S=N39)  {
		N39= S->next;

					if (S->kind=='W')
						len= put_string(result,len,S->data);
					else
						len= put_token(result,len,S->kind);
				
    } }


			} else {
				len= put_string( result, len, T->data );
			}
		}
	
    } }


	if (result)
		result[len]= 0;
	return len+1;
}

 static  int put_string(char *result, int len, char *src) {
	int L= strlen(src);
	if (result) {
		memcpy(result+len, src, L);
		result[len+L]= ' ';
	}
	len+= L+1;
	return len;
}

 static  int put_token(char *result, int len, int tk) {
	char buf[2];
	buf[0]= tk;
	buf[1]= 0;
	return put_string(result, len, buf);
}


arg_t *strprepend(arg_t *call,frame_t *F) {
	char *varname;
	arg_t *pfx;
	arg_t *lst;
	arg_t *value;
	char *pfxv;
	token_t *T;

	varname= get_varname(call, 0, "str.prepend");
	pfx= arglist(call,1);
	lst= arglist(call,2);

	value= arg_new();

	if (!pfx || !lst)
		wrong_args("str.prepend");
	pfxv= arg_to_string(pfx, F);

	  {
	void *N44;
	for(T=(&lst->tokens)->next;T!=(&lst->tokens);T=N44)  {
		N44= T->next;

		token_t *T3;
		arg_t *varval;
		if (T->kind!='W') {
			token_t *T2= token_copy_deep(T);
			 {
	(T2)->prev= ((&value->tokens))->prev; 
	(T2)->next= ((&value->tokens)); 
	((&value->tokens))->prev->next= (T2); 
	((&value->tokens))->prev= (T2); 
}


			continue;
		}
		if (T->data[0]!='$') {
			prepend_string_into_arg( pfxv, T->data, value, T->lineno);
			continue; 
		}
		varval= var_get(T->data, F);
		if (!varval)
			runtime_error("str.prepend", "can not find variable");
		  {
	void *N46;
	for(T3=(&varval->tokens)->next;T3!=(&varval->tokens);T3=N46)  {
		N46= T3->next;

			if (T3->kind=='W') 
				prepend_string_into_arg(pfxv, T3->data, value, T->lineno);
		
    } }


	
    } }


	var_set(varname, value, F);
	return 0;
}

 static  void prepend_string_into_arg(char *pfx,char *sfx, arg_t *a,int lno) {
	token_t *T2;
	char *v;
	v= mprintf("%s%s",pfx,sfx);
	T2= token_new();
	T2->kind= 'W';
	T2->data= v;
	T2->lineno= lno;
	 {
	(T2)->prev= ((&a->tokens))->prev; 
	(T2)->next= ((&a->tokens)); 
	((&a->tokens))->prev->next= (T2); 
	((&a->tokens))->prev= (T2); 
}


}
