-[ c library "ddepg.c", header "ddepg.h" ]

-[private] strtab_t all_files;
-[private] int fno;

-[public] void dump_dependency_graph() {
	-[ prepare command list & insert files ]
	printf("%d\n",fno+1);
	-[ dump the dependency graph ]
	/* dump the file names */
}

=[ prepare command list & insert files ]
	while(1) {
		strtab_t cmd;
		arg_t *A;
		cmdlist_t *C;
		if (command_get_one(&cmd))
			break;
		-[private] typedef struct cmdlist {
			struct cmdlist *prev, *next;
			strtab_t fields;
		} cmdlist_t;
		+[ private variables ]
		static cmdlist_t all_cmds= { &all_cmds, &all_cmds };
		+[ end ]
		-[ allocate object C ]
		C->fields= cmd;
		-[clist/insert C before (&all_cmds) ]
		A= strtab_find(&cmd,"outputs");
		if (A)
			insert_files_in(A);
		A= strtab_find(&cmd,"triggers");
		if (A)
			insert_files_in(A);
	}
=[]

-[private] void insert_files_in(arg_t *A) {
	token_t *T;
	-[ for each T in list (&A->tokens) , begin ]
		if (T->kind!='W') continue;
		if (!strtab_find(&all_files,T->data)) {
			strtab_insert(&all_files, T->data, (void*) fno);
			fno++;
		}
	-[ end ]
}

=[ dump the dependency graph ] {
	cmdlist_t *c;
	-[ for each c in list (&all_cmds) , begin ]
		arg_t *O;
		arg_t *T;
		token_t *To, *Tt;
		O= strtab_find(&c->fields, "outputs");
		if (!O) continue;
		T= strtab_find(&c->fields, "triggers");
		if (!T) continue;
		-[ for each To in list (&O->tokens) , begin ]
			int onr;
			if (To->kind!='W') continue;
			onr= (int) strtab_find(&all_files, To->data);
			-[ for each Tt in list (&T->tokens) , begin ]
				int tnr;
				if (Tt->kind!='W') continue;
				tnr= (int) strtab_find(&all_files, Tt->data);
				printf("%d %d\n", tnr, onr);
			-[ end ]
		-[ end ]
	-[ end ]
	printf("0 0\n");
}

=[]

-[ lheader "table.h" ]
-[ lheader "parser.h" ]
-[ lheader "command.h" ]
-[ header "stdio.h" ]
-[ header "stdlib.h" ]
