
-[ strlist_t : public list of char* ]

-[public] typedef struct {
	enum { fn_user, fn_builtin } kind;
	char *name;
	strlist_t args;
	void *data;
} func_t;

-[ functab_t : tree of func_t* , begin ]
	-[ scope = private ]
	-[ compare ]
		return strcmp(X1->name,X2->name);
-[ end ]

-[public] func_t* func_new(char *name)
{
	func_t *F;
	F= func_get(name);
	if (F) {
		char *X;
		while((X=strlist_destroy(&F->args))) {
			free(X);
		}
		if (F->kind==fn_user && F->data)
			free(F->data);
	} else {
		-[ allocate object F ]
		strlist_init(&F->args);
		F->name= strdup(name);
		functab_insert(funcs, F);
	}
	F->kind= fn_user;
	F->data= 0;
	return F;
}

-[public] func_t* func_get(char *name) {
	func_t fake;
	fake.name= name;
	func_t *R;
	R= functab_find(funcs, &fake);
	if (R) return R;
	return 0;
}

-[public] void func_remove(char *name) {
	func_t *F;
	F= func_get(name);
	if (F) {
		char *X;
		functab_remove(funcs,F);
		free(F->name);
		if (F->kind==fn_user && F->data)
			free(F->data);
		while((X=strlist_destroy(&F->args)))
			free(X);
		free(F);
	}
}



-[public] void func_init() {
	-[private] functab_t *funcs;
	-[ allocate object funcs ]
	functab_init(funcs);
}

-[ unused symbol functab_destroy ]

